BasicMethodLookupProfiler subclass: #CachingProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching Profiling'!

!CachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/12/2000 09:32'!
incrementCacheMiss

	^self subclassResponsibility
! !

!CachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 09:08'!
profileCacheLookup: aBlock

	^self subclassResponsibility
! !

!CachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/12/2000 09:10'!
profileCacheMaintenance: aBlock

	^self subclassResponsibility
! !

!CachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 10:01'!
profileExtraCacheLookupTime: aBlock.

	self subclassResponsibility.! !

!CachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 10:02'!
profileExtraMaintenanceTime: aBlock.

	self subclassResponsibility.! !


!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 6/16/2001 10:54'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	self printCacheHitsAsCsvOn: aStream.
	aStream comma.
	self printCacheMissAsCsvOn: aStream.
	aStream comma.
	self printLookupTimeAsCsvOn: aStream enclosedTime: aStopWatchTime.
	aStream comma.
	self printMaintenanceTimeAsCsvOn: aStream enclosedTime: aStopWatchTime.
	aStream comma.

	
! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 6/16/2001 10:50'!
printCacheHitsAsCsvOn: aStream

	aStream
		nextPutAll: self cacheHits printString;
		comma;
		nextPutAll: (self cacheHitsPerc roundTo: 0.01) printString.
	
! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 6/16/2001 10:51'!
printCacheMissAsCsvOn: aStream

	aStream
		nextPutAll: self cacheMiss printString;
		comma;
		nextPutAll: (self cacheMissPerc roundTo: 0.01) printString.
	
! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 7/5/2001 09:44'!
printLookedUpMessageAsCsvOn: aStream

	self lookedUpMessagesInCache printOn: aStream.
	

	
! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 7/5/2001 09:49'!
printLookupTimeAsCsvOn: aStream

	aStream 
		nextPutAll: self lookupCacheTime asMilliseconds valueAsString.

! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 7/5/2001 09:50'!
printLookupTimeAsCsvOn: aStream enclosedTime: aStopWatchTime

	aStream 
		nextPutAll: self lookupCacheTime asMilliseconds valueAsString;
		comma;
		nextPutAll: ((self lookupCacheTime percentOf: aStopWatchTime) roundTo: 0.01) printString.


! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 6/17/2001 23:50'!
printMaintenanceTimeAsCsvOn: aStream

	aStream
		nextPutAll: self maintenanceTime asMilliseconds valueAsString.
! !

!CachingProfiler methodsFor: 'printing as csv' stamp: 'HAW 6/17/2001 23:50'!
printMaintenanceTimeAsCsvOn: aStream enclosedTime: aStopWatchTime

	aStream
		nextPutAll: self maintenanceTime asMilliseconds valueAsString;
		comma;
		nextPutAll: ((self maintenanceTime percentOf: aStopWatchTime) roundTo: 0.01) printString.

! !


!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:52'!
printCacheHitsOn: aStream

	aStream
		nextPutAll: 'Cache Hits: ';
		nextPutAll: self cacheHits printString;
		nextPutAll: ' (';
		nextPutAll: (self cacheHitsPerc roundTo: 0.01) printString;
		nextPutAll: '%)'.
	
! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:52'!
printCacheMissOn: aStream

	aStream
		nextPutAll: 'Cache Miss: ';
		nextPutAll: self cacheMiss printString;
		nextPutAll: ' (';
		nextPutAll: (self cacheMissPerc roundTo: 0.01) printString;
		nextPutAll: '%)'.
	
! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 7/5/2001 09:44'!
printLookedUpMessageOn: aStream

	aStream nextPutAll: 'Total de mensajes buscados: '.
	self lookedUpMessagesInCache printOn: aStream.
	

	
! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 7/5/2001 09:50'!
printLookupTimeOn: aStream

	aStream 
		nextPutAll: 'Tiempo total de Busqueda ';
		nextPutAll: self lookupCacheTime asMilliseconds printString.

! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 7/5/2001 09:50'!
printLookupTimeOn: aStream enclosedTime: aStopWatchTime

	aStream 
		nextPutAll: 'Tiempo total de Bsqueda en Cache: ';
		nextPutAll: self lookupCacheTime asMilliseconds printString;
		nextPutAll: ' (';
		nextPutAll: ((self lookupCacheTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		nextPutAll: '%)'.


! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:53'!
printMaintenanceTimeOn: aStream

	aStream
		nextPutAll: 'Total de tiempo de Mantenimiento ';
		nextPutAll: self maintenanceTime asMilliseconds printString.
! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:53'!
printMaintenanceTimeOn: aStream enclosedTime: aStopWatchTime

	aStream
		nextPutAll: 'Total de tiempo de Mantenimiento de la Cache: ';
		nextPutAll: self maintenanceTime asMilliseconds printString;
		nextPutAll: ' (';
		nextPutAll: ((self maintenanceTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		nextPutAll: '%)'.

! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:53'!
printOn: aStream

	self printLookedUpMessageOn: aStream.
	aStream cr.
	self printCacheHitsOn: aStream.
	aStream cr.
	self printCacheMissOn: aStream.
	aStream cr.
	self printLookupTimeOn: aStream.
	aStream cr.
	self printMaintenanceTimeOn: aStream.
	
! !

!CachingProfiler methodsFor: 'printing' stamp: 'HAW 6/24/2001 23:16'!
printOn: aStream enclosedTime: aStopWatchTime

	self printCacheHitsOn: aStream.
	aStream cr.
	self printCacheMissOn: aStream.
	aStream cr.
	self printLookupTimeOn: aStream enclosedTime: aStopWatchTime.
	aStream cr.
	self printMaintenanceTimeOn: aStream enclosedTime: aStopWatchTime.
	aStream cr.

	
! !


!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:05'!
cacheHits

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:44'!
cacheHitsPerc

	^self cacheHits*100/self lookedUpMessagesInCache.! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/12/2000 09:14'!
cacheMiss

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:44'!
cacheMissPerc

	^self cacheMiss*100/self lookedUpMessagesInCache.! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:43'!
lookedUpMessagesInCache 

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:43'!
lookupCacheDeviationTime

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:43'!
lookupCacheTime

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:42'!
maintenanceDeviationTime

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:08'!
maintenanceTime

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:53'!
methodLookupTime

	^super methodLookupTime - ( self lookupCacheDeviationTime + self maintenanceDeviationTime + self totalExtraLookupCacheTime + self totalExtraMaintenanceTime).
! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:39'!
totalDeviationTime

	^super totalDeviationTime + self lookupCacheDeviationTime + self maintenanceDeviationTime + self totalExtraLookupCacheTime + self totalExtraMaintenanceTime.! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:40'!
totalExtraLookupCacheTime

	^self subclassResponsibility! !

!CachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:40'!
totalExtraMaintenanceTime

	^self subclassResponsibility! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CachingProfiler class
	instanceVariableNames: ''!

!CachingProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/12/2000 09:11'!
new

	^super new
		initialize;
		yourself.! !


CachingProfiler subclass: #BasicCachingProfiler
	instanceVariableNames: 'totalLookedUpMessages totalCacheMiss lookupStopWatch maintenanceStopWatch extraLookupTimeStopWatch extraMaintenanceTimeStopWatch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching Profiling'!

!BasicCachingProfiler methodsFor: 'private-access' stamp: 'HAW 12/12/2000 09:18'!
totalCacheMiss: aNumber

	totalCacheMiss _ aNumber! !

!BasicCachingProfiler methodsFor: 'private-access' stamp: 'HAW 12/12/2000 09:18'!
totalLookedUpMessages: aNumber

	totalLookedUpMessages _ aNumber.! !


!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/12/2000 09:33'!
incrementCacheMiss

	totalCacheMiss _ totalCacheMiss + 1! !

!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 09:08'!
profileCacheLookup: aBlock

	totalLookedUpMessages _ totalLookedUpMessages + 1.
	lookupStopWatch measure: aBlock.
! !

!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:43'!
profileCacheMaintenance: aBlock
	
	maintenanceStopWatch measure: aBlock.! !

!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 10:02'!
profileExtraCacheLookupTime: aBlock

	extraLookupTimeStopWatch measure: aBlock.! !

!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 10:02'!
profileExtraMaintenanceTime: aBlock

	extraMaintenanceTimeStopWatch measure: aBlock.! !

!BasicCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 10:01'!
startProfiling

	super startProfiling.
	lookupStopWatch clear.
	maintenanceStopWatch clear.
	extraLookupTimeStopWatch clear.
	extraMaintenanceTimeStopWatch clear.
! !


!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:44'!
cacheHits

	^self lookedUpMessagesInCache-self cacheMiss.

! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:09'!
cacheMiss

	^totalCacheMiss! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:44'!
lookedUpMessagesInCache

	^totalLookedUpMessages! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 10:08'!
lookupCacheDeviationTime

	^lookupStopWatch deviationTime.! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:39'!
lookupCacheTime

	^lookupStopWatch expendedTime - self totalExtraLookupCacheTime.! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:45'!
maintenanceDeviationTime

	^maintenanceStopWatch deviationTime.! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:34'!
maintenanceTime

	^maintenanceStopWatch expendedTime - self totalExtraMaintenanceTime.! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 11:38'!
totalExtraLookupCacheTime

	^extraLookupTimeStopWatch expendedTime + extraLookupTimeStopWatch deviationTime.! !

!BasicCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:34'!
totalExtraMaintenanceTime 

	^extraMaintenanceTimeStopWatch expendedTime + extraMaintenanceTimeStopWatch deviationTime.! !


!BasicCachingProfiler methodsFor: 'initialization' stamp: 'HAW 7/10/2001 10:27'!
initialize

	super initialize.
	self totalLookedUpMessages: 0.
	self totalCacheMiss: 0.
	lookupStopWatch _ StopWatch new.
	maintenanceStopWatch _ StopWatch new.
	extraLookupTimeStopWatch _ StopWatch new.
	extraMaintenanceTimeStopWatch _ StopWatch new.
! !


CachingProfiler subclass: #NullCachingProfiler
	instanceVariableNames: ''
	classVariableNames: 'Singleton '
	poolDictionaries: ''
	category: 'Thesis-Caching Profiling'!

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/19/2000 09:03'!
incrementCacheMiss
! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/5/2001 09:08'!
profileCacheLookup: aBlock

	aBlock value.! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/19/2000 09:16'!
profileCacheMaintenance: aBlock

	aBlock value.! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/10/2001 10:47'!
profileExtraTime: aBlock

	aBlock value.! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/10/2001 10:47'!
profileMethodLookup: aBlock

	aBlock value.! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 7/10/2001 10:47'!
selector: messageSelector sendTo: lookupClass
! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/19/2000 09:04'!
startProfiling! !

!NullCachingProfiler methodsFor: 'profiling' stamp: 'HAW 12/19/2000 09:04'!
stopProfiling! !


!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:13'!
cacheHits

	^0
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/19/2000 09:05'!
cacheMiss

	^0
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:48'!
extraDeviationTime

	^StopWatchTime cero.

! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:48'!
extraTime

	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:45'!
lookedUpMessagesInCache

	^0
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:46'!
lookupCacheDeviationTime
	
	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/5/2001 09:48'!
lookupCacheTime
	
	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:46'!
maintenanceDeviationTime
	
	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:13'!
maintenanceTime
	
	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:48'!
methodLookupDeviationTime

	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:48'!
methodLookupTime

	^StopWatchTime cero.
! !

!NullCachingProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 10:48'!
sendMessages

	^0.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NullCachingProfiler class
	instanceVariableNames: ''!

!NullCachingProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/20/2000 09:22'!
initializeSingleton

	Singleton _ super new.! !

!NullCachingProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/20/2000 09:23'!
new

	Singleton isNil ifTrue: [ self initializeSingleton ].
	^Singleton.

	! !
