BasicMethodLookupStrategy subclass: #CachingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!CachingStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 7/5/2001 08:52'!
lookupMethodForSelector: aSelector inClass: aClass

	self subclassResponsibility! !

!CachingStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 7/5/2001 09:04'!
methodLookupStrategy

	^self subclassResponsibility! !


!CachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 10:42'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	self subclassResponsibility! !

!CachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 12/19/2000 08:59'!
flushCache

	self subclassResponsibility! !

!CachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/12/2001 10:15'!
primitiveFlushCacheByMethod

	self subclassResponsibility! !

!CachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/12/2001 10:15'!
primitiveFlushCacheSelective

	self subclassResponsibility! !


!CachingStrategy methodsFor: 'initialization' stamp: 'HAW 12/19/2000 09:11'!
initialize

	self profiler: NullCachingProfiler new.! !

!CachingStrategy methodsFor: 'initialization' stamp: 'HAW 7/10/2001 11:16'!
performCacheInitalization: aSelector with: aCollaborator

	self perform: aSelector with: aCollaborator.! !

!CachingStrategy methodsFor: 'initialization' stamp: 'HAW 7/10/2001 15:05'!
performInitalization: aSelector with: aCollaborator

	self methodLookupStrategy perform: aSelector with: aCollaborator.! !


!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/7/2001 08:55'!
cacheEntries

	self subclassResponsibility.! !

!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 11:34'!
deviationTime

	^self profilingResult totalDeviationTime + self methodLookupStrategy deviationTime 
! !

!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 11:46'!
lookupTime

	^self profilingResult methodLookupTime - self methodLookupStrategy deviationTime.! !

!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 12:20'!
startProfiling

	self methodLookupStrategy startProfiling.
	^super startProfiling.! !

!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 12:20'!
stopProfiling

	self methodLookupStrategy stopProfiling.
	^super stopProfiling.! !

!CachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/7/2001 08:46'!
usedEntries

	self subclassResponsibility.! !


!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 8/7/2001 08:45'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	super printNameAsCsvOn: aStream.
	self printResultAsCsvOn: aStream enclosedTime: aStopWatchTime.
	self printMethodLookupStrategyAsCsvOn: aStream.
	self printNameAsCsvOn: aStream.
	self printProfilingResultAsCsvOn: aStream enclosedTime: self lookupTime. 
	self printUsedEntriesAsCsvOn: aStream.! !

!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 7/10/2001 18:33'!
printMethodLookupStrategyAsCsvOn: aStream 

	self methodLookupStrategy printAsCsvOn: aStream enclosedTime: (self lookupTime + self methodLookupStrategy extraTime)
! !

!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 6/16/2001 10:48'!
printNameAsCsvOn: aStream

	aStream 
		nextPutAll: self class name;
		comma.
! !

!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 6/16/2001 10:55'!
printProfilingResultAsCsvOn: aStream enclosedTime: aStopWatchTime
 
	self profilingResult printAsCsvOn: aStream enclosedTime: aStopWatchTime.! !

!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 7/19/2001 09:39'!
printResultAsCsvOn: aStream enclosedTime: aStopWatchTime
 
	aStream 
		nextPutAll: self lookupTime asMilliseconds valueAsString;
		comma;
		nextPutAll: ((self lookupTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		comma.! !

!CachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 8/7/2001 09:15'!
printUsedEntriesAsCsvOn: aStream

	aStream 
		nextPutAll: self usedEntries printString;
		comma;
		nextPutAll: ((self usedEntries*100/self cacheEntries) roundTo: 0.01) printString;
		comma.
! !


!CachingStrategy methodsFor: 'printing' stamp: 'HAW 7/10/2001 12:12'!
printMethodLookupStrategyOn: aStream 

	self methodLookupStrategy printOn: aStream enclosedTime: (self lookupTime + self methodLookupStrategy extraTime)
! !

!CachingStrategy methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:49'!
printNameOn: aStream

	aStream nextPutAll: 'Caching Strategy: ';
		nextPutAll: self class name;
		cr.
! !

!CachingStrategy methodsFor: 'printing' stamp: 'HAW 8/7/2001 08:46'!
printOn: aStream enclosedTime: aStopWatchTime

	super printNameOn: aStream.
	self printResultOn: aStream enclosedTime: aStopWatchTime.
	self printMethodLookupStrategyOn: aStream.
	self printNameOn: aStream.
	self printProfilingResultOn: aStream enclosedTime: self lookupTime. 
	self printUsedEntriesOn: aStream.! !

!CachingStrategy methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:49'!
printProfilingResultOn: aStream enclosedTime: aStopWatchTime

	self profilingResult printOn: aStream enclosedTime: aStopWatchTime.! !

!CachingStrategy methodsFor: 'printing' stamp: 'HAW 7/10/2001 11:24'!
printResultOn: aStream enclosedTime: aStopWatchTime
 
	aStream 
		nextPutAll: 'Tiempo total de Lookup: ';
		nextPutAll: self lookupTime asMilliseconds printString;
		nextPutAll: ' (';
		nextPutAll: ((self lookupTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		nextPutAll: '%)';
		cr.! !

!CachingStrategy methodsFor: 'printing' stamp: 'HAW 8/7/2001 09:16'!
printUsedEntriesOn: aStream

	aStream 
		nextPutAll: 'Used Entries: ';
		nextPutAll: self usedEntries printString;
		nextPutAll: ' (';
		nextPutAll: ((self usedEntries*100/self cacheEntries) roundTo: 0.01) printString;
		nextPutAll: '%)';
		cr.

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CachingStrategy class
	instanceVariableNames: ''!

!CachingStrategy class methodsFor: 'instance creation' stamp: 'HAW 12/12/2000 08:48'!
new

	^super new
		initialize;
		yourself.! !


CachingStrategy subclass: #BasicCachingStrategy
	instanceVariableNames: 'methodLookupStrategy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!BasicCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 11:06'!
lookupInCache: aSelector forClass: aClass

	^self subclassResponsibility.
! !


!BasicCachingStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 7/10/2001 11:09'!
lookupMethodForSelector: aSelector inClass: aClass

	| foundOnCache |

	profiler profileCacheLookup: [ foundOnCache _ self lookupInCache: aSelector forClass: aClass.].
	foundOnCache ifFalse: [
		profiler incrementCacheMiss.
		methodLookupStrategy findMethodForSelector: aSelector inClass: aClass.
		profiler profileCacheMaintenance: [ self addSelector: aSelector forClass: aClass 
			method: (interpreter newMethod) primitiveIndex: (interpreter primitiveIndex). ].
	].
! !

!BasicCachingStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 7/5/2001 09:04'!
methodLookupStrategy

	^methodLookupStrategy.! !

!BasicCachingStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 7/5/2001 09:04'!
methodLookupStrategy: aStrategy

	methodLookupStrategy _ aStrategy.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BasicCachingStrategy class
	instanceVariableNames: ''!

!BasicCachingStrategy class methodsFor: 'instance creation' stamp: 'HAW 7/10/2001 10:53'!
on: anInterpreter 

	^self on: anInterpreter withMethodLookupStrategy: (DispatchTableSearchML on: anInterpreter).
! !

!BasicCachingStrategy class methodsFor: 'instance creation' stamp: 'HAW 7/5/2001 09:32'!
on: anInterpreter withMethodLookupStrategy: aStrategy

	^super new
		interpreter: anInterpreter;
		methodLookupStrategy: aStrategy;
		yourself.! !


BasicCachingStrategy subclass: #AbstractSelectorCachingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!AbstractSelectorCachingStrategy methodsFor: 'accessing cache' stamp: 'HAW 8/11/2001 09:17'!
selectorsCache

	^self subclassResponsibility! !


!AbstractSelectorCachingStrategy methodsFor: 'cache statistics' stamp: 'HAW 8/11/2001 15:09'!
cacheStats

	| result usedEntries count |
	result _ Dictionary new.

	self selectorsCache do: [ :anArray |
		usedEntries _ self countUsedEntries: anArray.
		count _ result at: usedEntries ifAbsent: [0].
		result at: usedEntries put: count+1.].

	^result.! !

!AbstractSelectorCachingStrategy methodsFor: 'cache statistics' stamp: 'HAW 8/11/2001 09:15'!
countUsedEntries: aCache

	^self subclassResponsibility
! !


!AbstractSelectorCachingStrategy methodsFor: 'printing' stamp: 'HAW 8/11/2001 09:10'!
printOn: aStream enclosedTime: aStopWatchTime

	super printOn: aStream enclosedTime: aStopWatchTime.
	aStream 
		nextPutAll: 'Uso de la cache: ';
		nextPutAll: self cacheStats printString.! !


!AbstractSelectorCachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 8/11/2001 09:09'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	super printAsCsvOn: aStream enclosedTime: aStopWatchTime.
	self printDictionaryAsCsv: self cacheStats on: aStream.
! !

!AbstractSelectorCachingStrategy methodsFor: 'printing as csv' stamp: 'HAW 8/11/2001 09:10'!
printDictionaryAsCsv: aDictionary on: aStream

	aDictionary associationsDo: [ :assoc |
		aStream 
			nextPutAll: assoc key printString;
			comma;
			nextPutAll: assoc value printString;
			comma.
	].
! !


!AbstractSelectorCachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/11/2001 09:21'!
cacheEntries

	^self selectorsCache size*self cacheEntries.
! !

!AbstractSelectorCachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/11/2001 09:19'!
createProfiler

	^BasicCachingProfiler new.! !

!AbstractSelectorCachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/11/2001 09:27'!
usedEntries

	| usedEntries |

	usedEntries _ 0.
	self selectorsCache do: [ :aCache |
		usedEntries _ usedEntries + (self countUsedEntries: aCache).
	].

	^usedEntries.
! !


BasicCachingStrategy subclass: #GlobalCachingStrategy
	instanceVariableNames: 'methodCache methodCacheEntries methodCacheClass methodCacheMask methodCacheMethod methodCachePrim methodCacheSelector cacheProbeMax '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!GlobalCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/7/2001 10:07'!
addSelector: selector forClass: class method: meth primitiveIndex: primIndex
	"Add the given entry to the method cache.
	The policy is as follows:
		Look for an empty entry anywhere in the reprobe chain.
		If found, install the new entry there.
		If not found, then install the new entry at the first probe position
			and delete the entries in the rest of the reprobe chain.
		This has two useful purposes:
			If there is active contention over the first slot, the second
				or third will likely be free for reentry after ejection.
			Also, flushing is good when reprobe chains are getting full."
	| probe hash |
	hash _ selector bitXor: class.  "drop low-order zeros from addresses"

	0 to: cacheProbeMax-1 do:
		[:p | probe _ (hash >> p) bitAnd: methodCacheMask.
		(methodCache at: probe + methodCacheSelector) = 0 ifTrue:
				["Found an empty entry -- use it"
				methodCache at: probe + methodCacheSelector put: selector.
				methodCache at: probe + methodCacheClass put: class.
				methodCache at: probe + methodCacheMethod put: meth.
				methodCache at: probe + methodCachePrim put: primIndex.
				^ nil]].

	"OK, we failed to find an entry -- install at the first slot..."
	probe _ hash bitAnd: methodCacheMask.  "first probe"
	methodCache at: probe + methodCacheSelector put: selector.
	methodCache at: probe + methodCacheClass put: class.
	methodCache at: probe + methodCacheMethod put: meth.
	methodCache at: probe + methodCachePrim put: primIndex.

	"...and zap the following entries"
	1 to: cacheProbeMax-1 do:
		[:p | probe _ (hash >> p) bitAnd: methodCacheMask.
		methodCache at: probe + methodCacheSelector put: 0].

! !

!GlobalCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/12/2001 10:05'!
flushCache

	profiler profileCacheMaintenance: [ 
		1 to: self methodCacheSize do: [ :i | methodCache at: i put: 0 ].
		interpreter flushAtCache.].




! !

!GlobalCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 11:06'!
lookupInCache: selector forClass: class
	"This method implements a simple method lookup cache. If an entry for the given selector and class is found in the cache, set the values of 'newMethod' and 'primitiveIndex' and return true. Otherwise, return false."
	"About the re-probe scheme: The hash is the low bits of the XOR of two large addresses, minus their useless lowest two bits. If a probe doesn't get a hit, the hash is shifted right one bit to compute the next probe, introducing a new randomish bit. The cache is probed CacheProbeMax times before giving up."
	"WARNING: Since the hash computation is based on the object addresses of the class and selector, we must rehash or flush when compacting storage. We've chosen to flush, since that also saves the trouble of updating the addresses of the objects in the cache."

	| hash probe |
	hash _ selector bitXor: class.  "shift drops two low-order zeros from addresses"

	probe _ hash bitAnd: methodCacheMask.  "first probe"
	(((methodCache at: probe + methodCacheSelector) = selector) and:
		 [(methodCache at: probe + methodCacheClass) = class]) ifTrue:
			[interpreter newMethod: (methodCache at: probe + methodCacheMethod) 
						newPrimitiveIndex: (methodCache at: probe + methodCachePrim).
			^ true	"found entry in cache; done"].

	probe _ (hash >> 1) bitAnd: methodCacheMask.  "second probe"
	(((methodCache at: probe + methodCacheSelector) = selector) and:
		 [(methodCache at: probe + methodCacheClass) = class]) ifTrue:
			[interpreter newMethod: (methodCache at: probe + methodCacheMethod) 
						newPrimitiveIndex: (methodCache at: probe + methodCachePrim).
			^ true	"found entry in cache; done"].

	probe _ (hash >> 2) bitAnd: methodCacheMask.
	(((methodCache at: probe + methodCacheSelector) = selector) and:
		 [(methodCache at: probe + methodCacheClass) = class]) ifTrue:
			[interpreter newMethod: (methodCache at: probe + methodCacheMethod) 
						newPrimitiveIndex: (methodCache at: probe + methodCachePrim).
			^ true	"found entry in cache; done"].

	^ false

! !

!GlobalCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/12/2001 10:21'!
primitiveFlushCacheByMethod

	| probe oldMethod |

	profiler profileCacheMaintenance: [
		oldMethod _ interpreter stackTop.
		probe _ 0.
		1 to: self methodCacheEntries do: [:i | 
			(methodCache at: probe + methodCacheMethod) = oldMethod ifTrue:
				[methodCache at: probe + methodCacheSelector put: 0].
			probe _ probe + self methodCacheEntrySize].
		interpreter compilerFlushCacheHook: oldMethod.		"Flush the dynamic compiler's inline caches."
	].! !

!GlobalCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/12/2001 10:18'!
primitiveFlushCacheSelective

	| selector probe |

	profiler profileCacheMaintenance: [
		selector _ interpreter stackTop.
		probe _ 0.
		1 to: self methodCacheEntries do: [ :i | 
			(methodCache at: probe + methodCacheSelector) = selector ifTrue:
				[methodCache at: probe + methodCacheSelector put: 0].
			probe _ probe + self methodCacheEntrySize].
	].! !


!GlobalCachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/7/2001 08:56'!
cacheEntries

	^self methodCacheEntries.! !

!GlobalCachingStrategy methodsFor: 'profiling' stamp: 'HAW 12/19/2000 08:52'!
createProfiler

	^BasicCachingProfiler new.! !

!GlobalCachingStrategy methodsFor: 'profiling' stamp: 'HAW 8/7/2001 08:55'!
usedEntries

	| entry usedEntries |

	usedEntries _ 0.
	0 to: (self cacheEntries)-1 do: [ :anIndex |
		entry _ methodCache at: (anIndex*4) + 1.
		(entry isNil or: [ entry=0 ]) not ifTrue: [ usedEntries _ usedEntries + 1 ].
	].

	^usedEntries.
! !


!GlobalCachingStrategy methodsFor: 'cache setup' stamp: 'HAW 8/1/2001 09:52'!
defaultMethodCacheEntries

	^512.
! !

!GlobalCachingStrategy methodsFor: 'cache setup' stamp: 'HAW 6/12/2001 09:51'!
methodCacheEntries

	^methodCacheEntries.! !

!GlobalCachingStrategy methodsFor: 'cache setup' stamp: 'HAW 6/12/2001 09:53'!
methodCacheEntries: aNumber

	methodCacheEntries _ aNumber.
	self initializeMethodCache.! !

!GlobalCachingStrategy methodsFor: 'cache setup' stamp: 'HAW 6/12/2001 09:52'!
methodCacheEntrySize
	
	^4.! !

!GlobalCachingStrategy methodsFor: 'cache setup' stamp: 'HAW 6/12/2001 09:52'!
methodCacheSize

	^self methodCacheEntries*self methodCacheEntrySize.! !


!GlobalCachingStrategy methodsFor: 'initialization' stamp: 'HAW 6/12/2001 10:50'!
initialize

	super initialize.
	self methodCacheEntries: self defaultMethodCacheEntries.
	! !

!GlobalCachingStrategy methodsFor: 'initialization' stamp: 'HAW 8/7/2001 10:07'!
initializeMethodCache

	methodCacheSelector _ 1.
	methodCacheClass _ 2.
	methodCacheMethod _ 3.
	methodCachePrim _ 4.
	methodCacheMask _ (self methodCacheEntries - 1) * self methodCacheEntrySize.
	cacheProbeMax _ 3.

	methodCache _ Array new: self methodCacheSize.
	1 to: self methodCacheSize do: [ :i | methodCache at: i put: 0 ].

	! !


AbstractSelectorCachingStrategy subclass: #HBCachingStrategy
	instanceVariableNames: 'selectorsCache cacheEntries cacheEntriesByEntrySize entrySize '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 15:45'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

"Hacer una clase para cada una de las maneras de agregar en la cache
Estrategia 1: Cuando se llena agregar en la posicion 1 y borrar toda cache - Solo la siguiente entrada porque para de buscar cuando encuentra un nil
Estrategia 2: Cuando se llena la chace agregar de manera circular. Podria mantener un numero por cache o global. El mantenerlo por cache me ayuda a que no tenga que buscar un espacio vacio, sino que agrego siempre donde dice ese indice
Estrategia 3: Agrego en el lessUsedEntry - Puede ser que siempre este sacando el ultimo que agrege...
Estrategia 4: Agrego en el oldest - Complejo de implementar...."

	^self subclassResponsibility.! !

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 15:33'!
createSelectorCache

	^Array new: cacheEntriesByEntrySize.
	
! !

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 15:20'!
flushCache

	profiler profileCacheMaintenance: [ 
		selectorsCache _ Dictionary new.
		interpreter flushAtCache.].



! !

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 16:09'!
lookupInCache: aSelector forClass: aClass

	| cache classNumber from |
 
	profiler profileExtraCacheLookupTime: [ 
		cache _ selectorsCache at: aSelector ifAbsentPut: [self createSelectorCache.].
		classNumber _ methodLookupStrategy classNumberFor: aClass. ].

	1 to: cacheEntriesByEntrySize by: entrySize do: [ :index |
		from _ cache at: index.
		from isNil ifTrue: [ ^false. ].
		from <= classNumber ifTrue: [ 
			classNumber < (cache at: (index+1)) ifTrue: [
				interpreter newMethod: (cache at: (index+2) ) newPrimitiveIndex: (cache at: (index+3) ).
				^true.
			].
		].
	].

	^false.
! !

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 15:21'!
primitiveFlushCacheByMethod

	^self error: 'Not implemented yet'.! !

!HBCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 15:21'!
primitiveFlushCacheSelective

	^self error: 'Not implemented yet'.! !


!HBCachingStrategy methodsFor: 'initialization' stamp: 'HAW 8/21/2001 15:15'!
initialize

	super initialize.
	selectorsCache _ Dictionary new.
	cacheEntries _ 3.
	entrySize _ 4.
	cacheEntriesByEntrySize _ cacheEntries * entrySize.
! !


!HBCachingStrategy methodsFor: 'cache statistics' stamp: 'HAW 8/11/2001 15:58'!
countUsedEntries: aCache
	
	| entry usedEntries |

	usedEntries _ 0.
	1 to: cacheEntriesByEntrySize by: entrySize do: [ :anIndex | 
		entry _ aCache at: anIndex.
		"Stop counting on the first nil"
		entry notNil ifTrue: [ usedEntries _ usedEntries + 1 ] ifFalse: [^usedEntries].
	].

	^usedEntries! !


!HBCachingStrategy methodsFor: 'accesing cache' stamp: 'HAW 8/11/2001 09:22'!
cacheEntries

	^cacheEntries.! !

!HBCachingStrategy methodsFor: 'accesing cache' stamp: 'HAW 8/11/2001 09:22'!
selectorsCache

	^selectorsCache.! !


HBCachingStrategy subclass: #HBCacheCircularAddCachingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!HBCacheCircularAddCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 16:06'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	| cache indexToAdd |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].
	
	indexToAdd _ cache last.

	cache at: indexToAdd put: methodLookupStrategy lastFrom.
	cache at: (indexToAdd+1) put: methodLookupStrategy lastTo.
	cache at: (indexToAdd+2) put: aMethod. 
	cache at: (indexToAdd+3) put: aPrimitiveIndex.

	cache at: (cache size) put: (indexToAdd + entrySize)\\cacheEntriesByEntrySize.
	! !

!HBCacheCircularAddCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 15:47'!
createSelectorCache
	
	| cache size |
	size _ cacheEntriesByEntrySize + 1.
	cache _ Array new: size.
	cache at: size put: 1.
	^cache.
	
! !


HBCachingStrategy subclass: #HBEraseAllCachingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!HBEraseAllCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 16:06'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	| cache |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].

	1 to: cacheEntriesByEntrySize by: entrySize do: [ :index |
		(cache at: index) isNil ifTrue: [ 
			cache at: index put: methodLookupStrategy lastFrom.
			cache at: (index+1) put: methodLookupStrategy lastTo.
			cache at: (index+2) put: aMethod. 
			cache at: (index+3) put: aPrimitiveIndex.
			^self.
		].
	].

	"No space in the cache. Put the new entry at first position"
	cache at: 1 put: methodLookupStrategy lastFrom.
	cache at: 2 put: methodLookupStrategy lastTo.
	cache at: 3 put: aMethod.
	cache at: 4 put: aPrimitiveIndex.

	"Putting nil in the second position means that the rest of the cache is empy"
	cache at: 5 put: nil.
! !


HBCachingStrategy subclass: #HBGlobalCircularAddCachingStrategy
	instanceVariableNames: 'indexToAdd '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!HBGlobalCircularAddCachingStrategy methodsFor: 'initialization' stamp: 'HAW 8/11/2001 15:41'!
initialize

	super initialize.
	indexToAdd _ 1.! !


!HBGlobalCircularAddCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 16:06'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	| cache |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].

	1 to: cacheEntriesByEntrySize by: entrySize do: [ :index |
		(cache at: index) isNil ifTrue: [ 
			cache at: index put: methodLookupStrategy lastFrom.
			cache at: (index+1) put: methodLookupStrategy lastTo.
			cache at: (index+2) put: aMethod. 
			cache at: (index+3) put: aPrimitiveIndex.
			^self.
		].
	]. 

	cache at: indexToAdd put: methodLookupStrategy lastFrom.
	cache at: (indexToAdd+1) put: methodLookupStrategy lastTo.
	cache at: (indexToAdd+2) put: aMethod. 
	cache at: (indexToAdd+3) put: aPrimitiveIndex.

	indexToAdd _ (indexToAdd + entrySize)\\cacheEntriesByEntrySize.
! !


HBCachingStrategy subclass: #HBOneEntryCachingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!HBOneEntryCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 16:21'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	| cache |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].

	cache at: 1 put: methodLookupStrategy lastFrom.
	cache at: 2 put: methodLookupStrategy lastTo.
	cache at: 3 put: aMethod. 
	cache at: 4 put: aPrimitiveIndex.

! !

!HBOneEntryCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/11/2001 16:24'!
lookupInCache: aSelector forClass: aClass

	| cache classNumber from |
 
	profiler profileExtraCacheLookupTime: [ 
		cache _ selectorsCache at: aSelector ifAbsentPut: [self createSelectorCache.].
		classNumber _ methodLookupStrategy classNumberFor: aClass. ].

	from _ cache at: 1.
	from isNil ifTrue: [ ^false. ].
	from <= classNumber ifTrue: [ 
		classNumber < (cache at: 2) ifTrue: [
			interpreter newMethod: (cache at: 3 ) newPrimitiveIndex: (cache at: 4 ).
			^true.
		].
	].

	^false.
! !


!HBOneEntryCachingStrategy methodsFor: 'initialization' stamp: 'HAW 8/11/2001 16:22'!
initialize

	super initialize.
	selectorsCache _ Dictionary new.
	cacheEntries _ 1.
	entrySize _ 4.
	cacheEntriesByEntrySize _ cacheEntries * entrySize.
! !


AbstractSelectorCachingStrategy subclass: #SelectorCachingStrategy
	instanceVariableNames: 'selectorsCache cacheEntries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Caching strategies'!

!SelectorCachingStrategy methodsFor: 'initialization' stamp: 'HAW 6/17/2001 18:49'!
initialize

	super initialize.
	selectorsCache _ Dictionary new.
	cacheEntries _ 4.! !


!SelectorCachingStrategy methodsFor: 'cache statistics' stamp: 'HAW 8/11/2001 09:14'!
countUsedEntries: aCache
	
	| entry usedEntries |

	usedEntries _ 0.
	1 to: 4 do: [ :anIndex |
		entry _ aCache at: anIndex.
		(entry isNil or: [entry=0]) not ifTrue: [ usedEntries _ usedEntries + 1 ].
	].

	^usedEntries! !


!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/5/2001 09:13'!
addSelector2: aSelector forClass: aClass

	| cache probe |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].
	probe _ ((aClass>>2) bitAnd: 3)+1.
	(cache at: probe) isNil ifTrue: [
		cache at: probe  put: aClass.
		cache at: probe + 4 put: (interpreter newMethod).
		cache at: probe + 8 put: (interpreter primitiveIndex).
		^self. ].

	probe=4 ifTrue: [
		probe _ 1. ]
	ifFalse: [
		probe _ probe + 1. ].

	(cache at: probe) isNil ifTrue: [
		cache at: probe  put: aClass.
		cache at: probe + 4 put: (interpreter newMethod).
		cache at: probe + 8 put: (interpreter primitiveIndex).
		^self ].

	"There is no empty space to add the entry, so I erase this one and..."
	cache at: probe  put: nil.
	cache at: probe + 4 put: nil.
	cache at: probe + 8 put: nil.

	"Add the new entry in the first place..."		
	probe _ ((aClass>>2) bitAnd: 3)+1.
	cache at: probe  put: aClass.
	cache at: probe + 4 put: (interpreter newMethod).
	cache at: probe + 8 put: (interpreter primitiveIndex).
! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 7/10/2001 10:40'!
addSelector: aSelector forClass: aClass method: aMethod primitiveIndex: aPrimitiveIndex

	| cache probe |

	profiler profileExtraMaintenanceTime: [ cache _ selectorsCache at: aSelector. ].
	probe _ ((aClass>>2) bitAnd: 3)+1.
	cache at: probe  put: aClass.
	cache at: probe + 4 put: aMethod.
	cache at: probe + 8 put: aPrimitiveIndex.
! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/17/2001 18:40'!
createSelectorCache

	^Array new: (3 * cacheEntries).
	
! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/17/2001 19:06'!
flushCache

	profiler profileCacheMaintenance: [ 
		selectorsCache _ Dictionary new.
		interpreter flushAtCache.].



! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/17/2001 21:33'!
lookupInCache2: aSelector class: aClass

	| cache probe |

	profiler profileExtraLookupTime: [ cache _ selectorsCache at: aSelector ifAbsentPut: [self createSelectorCache.]. ].
	probe _ ((aClass>>2) bitAnd: 3)+1.
	(cache at: probe)=aClass ifTrue: [
		interpreter newMethod: (cache at: probe + 4 )
					newPrimitiveIndex: (cache at: probe + 8 ).
		^true.
	].

	probe=4 ifTrue: [
		probe _ 1. ]
	ifFalse: [
		probe _ probe + 1. ].

	(cache at: probe)=aClass ifTrue: [
		interpreter newMethod: (cache at: probe + 4 )
					newPrimitiveIndex: (cache at: probe + 8 ).
		^true.
	].

	^false.! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 8/9/2001 09:05'!
lookupInCache: aSelector forClass: aClass

	| cache probe |

	profiler profileExtraCacheLookupTime: [ cache _ selectorsCache at: aSelector ifAbsentPut: [self createSelectorCache.]. ].
	probe _ ((aClass>>2) bitAnd: 3)+1.
	(cache at: probe)=aClass ifTrue: [
		interpreter newMethod: (cache at: probe + 4 )
					newPrimitiveIndex: (cache at: probe + 8 ).
		^true.
	].

	^false.! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/17/2001 19:07'!
primitiveFlushCacheByMethod

	^self error: 'Not implemented yet'.! !

!SelectorCachingStrategy methodsFor: 'caching behavior' stamp: 'HAW 6/17/2001 19:07'!
primitiveFlushCacheSelective

	^self error: 'Not implemented yet'.! !


!SelectorCachingStrategy methodsFor: 'accesing cache' stamp: 'HAW 8/11/2001 09:21'!
cacheEntries

	^cacheEntries.! !

!SelectorCachingStrategy methodsFor: 'accesing cache' stamp: 'HAW 8/11/2001 09:18'!
selectorsCache

	^selectorsCache.! !
