InterpreterSimulatorLSB subclass: #RunnableInterpreter
	instanceVariableNames: 'endRunning '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Interpreter'!

!RunnableInterpreter methodsFor: 'other primitives' stamp: 'HAW 1/21/2000 15:48'!
primitiveQuit
	endRunning _ true.! !


!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 09:53'!
basicRun: anImageFileName runBlock: aBlock

	| display |
	Smalltalk snapshot: true andQuit: false.
	display _ DisplayScreen allInstances at: 1.
	display restoreAfter: [ 
		self openOn: anImageFileName. "extraMemory: 4000000"
		self class initialize. "I have to do this to initialize primitiveTable...."
		aBlock value.
		self close. ].
	Cursor normal show.

	^self.! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:08'!
profile: anImageFileName

	self basicRun: anImageFileName runBlock: self profileBlock.

! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:11'!
profileBlock
	^ [ MessageTally 
		spyOn: self runBlock
		every: 1.].
! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:11'!
profileSends: anImageFileName

	self basicRun: anImageFileName runBlock: self profileSendsBlock.

! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:12'!
profileSendsBlock
	^ [ MessageTally 
		tallySends: self runBlock. ].
! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:10'!
run: anImageFileName

	self basicRun: anImageFileName runBlock: self runBlock.

! !

!RunnableInterpreter methodsFor: 'running' stamp: 'HAW 6/16/2001 10:10'!
runBlock

	^ [byteCount _ 0.
	self internalizeIPandSP.
	self fetchNextBytecode.
	endRunning _ false.
	[endRunning] whileFalse:
		[self dispatchOn: currentBytecode in: BytecodeTable.
		byteCount _ byteCount + 1].
	self externalizeIPandSP.].
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

RunnableInterpreter class
	instanceVariableNames: ''!

!RunnableInterpreter class methodsFor: 'instance creation' stamp: 'HAW 12/6/2000 08:52'!
run
	^self run: self defaultImageFileName.! !

!RunnableInterpreter class methodsFor: 'instance creation' stamp: 'HAW 12/6/2000 08:46'!
run: anImageFileName
	^super new
		run: anImageFileName.! !


!RunnableInterpreter class methodsFor: 'image support' stamp: 'HAW 12/6/2000 08:52'!
defaultImageFileName

	^'\development\thesis\squeak\ce\squeak2.1.image'.! !


RunnableInterpreter subclass: #ConfigMLInterpreter
	instanceVariableNames: 'methodLookupStrategy test testMethodLookupStrategy originalMethodLookupStrategy methodLookupStrategies '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Interpreter'!

!ConfigMLInterpreter methodsFor: 'initialization' stamp: 'HAW 1/9/2001 09:09'!
initialize
	
	self initializeMethodLookupStrategies.
	^super initialize! !

!ConfigMLInterpreter methodsFor: 'initialization' stamp: 'HAW 8/11/2001 16:25'!
initializeMethodLookupStrategies

	methodLookupStrategies _ Dictionary new.
	methodLookupStrategies
		at: 1 put: [ DispatchTableSearchML on: self. ];
		at: 2 put: [ GlobalCachingStrategy on: self withMethodLookupStrategy: (DispatchTableSearchML on: self). ];
		at: 3 put: [ DTSWithClassesML on: self. ];
		at: 4 put: [ HierarchyBranchML on: self. ];
		at: 5 put: [ HierarchyBranchWithDicML on: self. ];
		at: 6 put: [ GlobalCachingStrategy on: self withMethodLookupStrategy: (DTSWithClassesML on: self). ];
		at: 7 put: [ GlobalCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchML on: self). ];
		at: 8 put: [ GlobalCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchWithDicML on: self). ];
		at: 9 put: [ SelectorCachingStrategy on: self withMethodLookupStrategy: (DispatchTableSearchML on: self). ];
		at: 10 put: [ DispatchTableSearchML on: self. ]; "FullDictionaryML on: self. ];"
		at: 11 put: [ GlobalCachingStrategy on: self withMethodLookupStrategy: (FullDictionaryML on: self). ];
		at: 12 put: [ HBEraseAllCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchML on: self).];
		at: 13 put: [ HBGlobalCircularAddCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchML on: self).];
		at: 14 put: [ HBCacheCircularAddCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchML on: self).];
		at: 15 put: [ HBOneEntryCachingStrategy on: self withMethodLookupStrategy: (HierarchyBranchML on: self).].! !


!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 11:01'!
currentMethodLookupStrategy

	^methodLookupStrategy


! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 11:01'!
currentMethodLookupStrategy: aMethodLookupStrategy

	methodLookupStrategy _ aMethodLookupStrategy.

! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 10:58'!
originalMethodLookupStrategy

	^originalMethodLookupStrategy! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 10:58'!
originalMethodLookupStrategy: aMethodLookupStrategy

	originalMethodLookupStrategy _ aMethodLookupStrategy.! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 11:00'!
restoreOriginalMethodLookupStrategy

	self currentMethodLookupStrategy: self originalMethodLookupStrategy.! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 10:58'!
testMethodLookupStrategy

	^testMethodLookupStrategy.! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 10:58'!
testMethodLookupStrategy: aMethodLookupStrategy

	testMethodLookupStrategy _ aMethodLookupStrategy.! !

!ConfigMLInterpreter methodsFor: 'method lookup strategy' stamp: 'HAW 6/12/2001 10:59'!
useTestMethodLookupStrategy

	self originalMethodLookupStrategy: self currentMethodLookupStrategy.
	self currentMethodLookupStrategy: self testMethodLookupStrategy.! !


!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:09'!
addToMethodCacheSel: selector class: class method: meth primIndex: primIndex

	^self error: 'Should not be called'! !

!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:08'!
flushAtCache

	1 to: AtCacheTotalSize do: [ :i | atCache at: i put: 0 ].
! !

!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:08'!
flushMethodCache

	methodLookupStrategy flushCache.! !

!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:09'!
lookupInMethodCacheSel: selector class: class

	^self error: 'Should not be called'! !

!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:10'!
primitiveFlushCacheByMethod

	methodLookupStrategy primitiveFlushCacheSelective.! !

!ConfigMLInterpreter methodsFor: 'method lookup cache' stamp: 'HAW 6/12/2001 10:10'!
primitiveFlushCacheSelective

	methodLookupStrategy primitiveFlushCacheSelective.! !


!ConfigMLInterpreter methodsFor: 'message sending' stamp: 'HAW 6/12/2001 11:05'!
findNewMethodInClass: aClass

	^self currentMethodLookupStrategy findMethodForSelector: messageSelector inClass: aClass.
! !

!ConfigMLInterpreter methodsFor: 'message sending' stamp: 'HAW 6/12/2001 11:05'!
internalFindNewMethod

	^self currentMethodLookupStrategy findMethodForSelector: messageSelector inClass: lkupClass.! !

!ConfigMLInterpreter methodsFor: 'message sending' stamp: 'HAW 12/26/2000 09:16'!
superFindNewMethodInClass: aClass

	^super findNewMethodInClass: aClass
! !


!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:43'!
maxPrimitiveIndex

	^MaxPrimitiveIndex! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:23'!
messageDictionaryIndex

	^MessageDictionaryIndex.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:35'!
messageSelector

	^messageSelector.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:35'!
messageSelector: aSelector

	messageSelector _ aSelector.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:40'!
methodArrayIndex

	^MethodArrayIndex.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 12/5/2000 08:46'!
newMethod
	^newMethod! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:46'!
newMethod: aNewMethod
	newMethod _ aNewMethod.
	primitiveIndex _ self primitiveIndexOf: aNewMethod.
	primitiveIndex > MaxPrimitiveIndex ifTrue:
		["If primitiveIndex is out of range, set to zero before putting in cache.
		This is equiv to primFail, and avoids the need to check on every send."
		primitiveIndex _ 0].
! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/12/2001 09:38'!
newMethod: aNewMethod newPrimitiveIndex: anIndex
	newMethod _ aNewMethod.
	primitiveIndex _ anIndex.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 12/5/2000 08:46'!
primitiveIndex
	^primitiveIndex! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:29'!
selectorCannotInterpret

	^self splObj: SelectorCannotInterpret.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:33'!
selectorDoesNotUnderstand

	^self splObj: SelectorDoesNotUnderstand.! !

!ConfigMLInterpreter methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:37'!
selectorStart

	^SelectorStart! !


!ConfigMLInterpreter methodsFor: 'setup primitives' stamp: 'HAW 6/13/2001 08:48'!
initializeCache: aMethodLookupStrategy with: anInitializationMessagesArrayOrNil
	| association selector parameter |

	anInitializationMessagesArrayOrNil = self nilObject ifFalse: [
		1 to: (self lengthOf: anInitializationMessagesArrayOrNil) do: [ :anIndex |
			association := self fetchPointer: (anIndex - 1) ofObject: anInitializationMessagesArrayOrNil.
			selector := (self stringOf: (self fetchPointer: 0 ofObject: association)) asSymbol.
			parameter := self fetchPointer: 1 ofObject: association.
			(self isIntegerObject: parameter) ifTrue: [ parameter _ self integerValueOf: parameter ].
			aMethodLookupStrategy performCacheInitalization: selector with: parameter. ].
		].! !

!ConfigMLInterpreter methodsFor: 'setup primitives' stamp: 'HAW 6/13/2001 08:48'!
initializeMethodLookup: aMethodLookupStrategy with: anInitializationMessagesArrayOrNil

	| association selector parameter |

	anInitializationMessagesArrayOrNil = self nilObject ifFalse: [
		1 to: (self lengthOf: anInitializationMessagesArrayOrNil) do: [ :anIndex |
			association := self fetchPointer: (anIndex - 1) ofObject: anInitializationMessagesArrayOrNil.
			selector := (self stringOf: (self fetchPointer: 0 ofObject: association)) asSymbol.
			parameter := self fetchPointer: 1 ofObject: association.
			(self isIntegerObject: parameter) ifTrue: [ parameter _ self integerValueOf: parameter ].
			aMethodLookupStrategy performInitalization: selector with: parameter. ].
		].! !

!ConfigMLInterpreter methodsFor: 'setup primitives' stamp: 'HAW 6/11/2001 01:50'!
methodLookupForKey: aMethodLookupKey

	| methodLookupStrategyCreationBlock |

	"Si el numero es 0, significa que hay que seguir usando el mismo MethodLookup"
	aMethodLookupKey=0 ifTrue: [
		^self methodLookupStrategy.]
	ifFalse: [
		methodLookupStrategyCreationBlock _ methodLookupStrategies 
			at: aMethodLookupKey ifAbsent: [self error: 'Invalid Method Lookup Key' ].
		^methodLookupStrategyCreationBlock value. ].! !

!ConfigMLInterpreter methodsFor: 'setup primitives' stamp: 'HAW 6/13/2001 08:51'!
primitiveUseCacheMethodLookup

	| methodLookupKey methodLookup initializationMessages cacheInitializationMessages |

	methodLookupKey _ self integerValueOf: (self stackValue: 2).
	methodLookup _ self methodLookupForKey: methodLookupKey.
	initializationMessages _ self stackValue: 1.
	cacheInitializationMessages _ self stackValue: 0.
	self initializeMethodLookup: methodLookup with: initializationMessages.
	self initializeCache: methodLookup with: cacheInitializationMessages.
	self testMethodLookupStrategy: methodLookup.
! !

!ConfigMLInterpreter methodsFor: 'setup primitives' stamp: 'HAW 6/13/2001 08:56'!
primitiveUseMethodLookup

	| methodLookupKey methodLookup initializationMessages |

	methodLookupKey _ self integerValueOf: (self stackValue: 1).
	methodLookup _ self methodLookupForKey: methodLookupKey.
	initializationMessages _ self stackValue: 0.
	self initializeMethodLookup: methodLookup with: initializationMessages.
	self testMethodLookupStrategy: methodLookup.
! !


!ConfigMLInterpreter methodsFor: 'test primitives' stamp: 'HAW 6/17/2001 22:20'!
primitiveStartTest
	| name |

	name _ self stringOf: (self stackValue: argumentCount - 1).
	test _ Test named: name for: self testMethodLookupStrategy.
	self useTestMethodLookupStrategy.

	Smalltalk garbageCollect.

	test startProfiling.


! !

!ConfigMLInterpreter methodsFor: 'test primitives' stamp: 'HAW 8/15/2001 09:30'!
primitiveStopTest

	| printingType |

	test stopProfiling.
	self restoreOriginalMethodLookupStrategy.

	printingType _ self integerValueOf: (self stackValue: argumentCount - 1).

	printingType=0 ifTrue: [
		self printTestStats. ]
	ifFalse: [
		self printTestStatsAsCsv.].

! !

!ConfigMLInterpreter methodsFor: 'test primitives' stamp: 'HAW 6/16/2001 10:59'!
printTestStats
	| stream |

	stream _ WriteStream on: String new.
	test printOn: stream.
	Transcript  
		show: stream contents;
		show: '-----------------------------------------------------';
		cr.

	
	

! !

!ConfigMLInterpreter methodsFor: 'test primitives' stamp: 'HAW 6/16/2001 10:59'!
printTestStatsAsCsv
	| stream |

	stream _ WriteStream on: String new.
	test printAsCsvOn: stream.
	Transcript  
		show: stream contents;
		cr.

	
	

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

ConfigMLInterpreter class
	instanceVariableNames: ''!

!ConfigMLInterpreter class methodsFor: 'constants' stamp: 'HAW 12/12/2000 09:50'!
PrimStartTestIndex
	^ 571.
! !

!ConfigMLInterpreter class methodsFor: 'constants' stamp: 'HAW 12/12/2000 09:50'!
PrimStopTestIndex
	^ 572.
! !

!ConfigMLInterpreter class methodsFor: 'constants' stamp: 'HAW 6/12/2001 10:32'!
PrimUseCacheMethodLookup
	^ 574.! !

!ConfigMLInterpreter class methodsFor: 'constants' stamp: 'HAW 1/9/2001 08:57'!
PrimUseMethodLookup
	^ 573.! !


!ConfigMLInterpreter class methodsFor: 'run' stamp: 'HAW 6/12/2001 11:03'!
run: anImageFileName using: aMethodLookupStrategyClass

	| interpreter |

	interpreter _ self new.
	interpreter
		currentMethodLookupStrategy: (aMethodLookupStrategyClass on: interpreter);
		run: anImageFileName
		yourself.
! !

!ConfigMLInterpreter class methodsFor: 'run' stamp: 'HAW 12/6/2000 08:55'!
runUsing: aMethodLookupStrategyClass

	^self run: (self defaultImageFileName) using: aMethodLookupStrategyClass
! !

!ConfigMLInterpreter class methodsFor: 'run' stamp: 'HAW 12/6/2000 08:56'!
runUsingDTS

	^self runUsing: DispatchTableSearchML.! !

!ConfigMLInterpreter class methodsFor: 'run' stamp: 'HAW 7/10/2001 10:54'!
runUsingGLC

	^self runUsing: GlobalCachingStrategy.! !


!ConfigMLInterpreter class methodsFor: 'run profiling sends' stamp: 'HAW 6/16/2001 10:04'!
profileSends: anImageFileName using: aMethodLookupStrategyClass

	| interpreter |

	interpreter _ self new.
	interpreter
		currentMethodLookupStrategy: (aMethodLookupStrategyClass on: interpreter);
		profileSends: anImageFileName
		yourself.
! !

!ConfigMLInterpreter class methodsFor: 'run profiling sends' stamp: 'HAW 6/16/2001 10:04'!
profileSendsUsing: aMethodLookupStrategyClass

	^self profileSends: (self defaultImageFileName) using: aMethodLookupStrategyClass 
! !

!ConfigMLInterpreter class methodsFor: 'run profiling sends' stamp: 'HAW 6/16/2001 10:03'!
profileSendsUsingDTS

	^self profileSendsUsing: DispatchTableSearchML.! !

!ConfigMLInterpreter class methodsFor: 'run profiling sends' stamp: 'HAW 6/16/2001 09:34'!
profileSendsUsingGLC

	^self profileSendsUsing: CachedMethodLookup.! !


!ConfigMLInterpreter class methodsFor: 'run profiling' stamp: 'HAW 6/16/2001 09:59'!
profile: anImageFileName using: aMethodLookupStrategyClass

	| interpreter |

	interpreter _ self new.
	interpreter
		currentMethodLookupStrategy: (aMethodLookupStrategyClass on: interpreter);
		profile: anImageFileName
		yourself.
! !

!ConfigMLInterpreter class methodsFor: 'run profiling' stamp: 'HAW 6/16/2001 09:59'!
profileUsing: aMethodLookupStrategyClass

	^self profile: (self defaultImageFileName) using: aMethodLookupStrategyClass 
! !

!ConfigMLInterpreter class methodsFor: 'run profiling' stamp: 'HAW 6/16/2001 10:03'!
profileUsingDTS

	^self profileUsing: DispatchTableSearchML.! !

!ConfigMLInterpreter class methodsFor: 'run profiling' stamp: 'HAW 6/16/2001 09:29'!
profileUsingGLC

	^self profileUsing: CachedMethodLookup.! !


!ConfigMLInterpreter class methodsFor: 'instance creation' stamp: 'HAW 6/16/2001 09:29'!
run: anImageFileName using: aMethodLookupStrategyClass profile: aNumberOfByteCodes

	| interpreter |

	interpreter _ self new.
	interpreter
		currentMethodLookupStrategy: (aMethodLookupStrategyClass on: interpreter);
		openOn: anImageFileName;
		profile: aNumberOfByteCodes;
		yourself.
! !

!ConfigMLInterpreter class methodsFor: 'instance creation' stamp: 'HAW 6/16/2001 09:35'!
run: anImageFileName using: aMethodLookupStrategyClass profileSends: aNumberOfByteCodes

	| interpreter |

	interpreter _ self new.
	interpreter
		currentMethodLookupStrategy: (aMethodLookupStrategyClass on: interpreter);
		openOn: anImageFileName;
		profileSends: aNumberOfByteCodes;
		yourself.
! !


!ConfigMLInterpreter class methodsFor: 'initialization' stamp: 'HAW 6/12/2001 10:32'!
initializePrimitiveTable 
	super initializePrimitiveTable.
	PrimitiveTable at: (self PrimStartTestIndex) put: #primitiveStartTest.
	PrimitiveTable at: (self PrimStopTestIndex) put: #primitiveStopTest.
	PrimitiveTable at: (self PrimUseMethodLookup) put: #primitiveUseMethodLookup.
	PrimitiveTable at: (self PrimUseCacheMethodLookup) put: #primitiveUseCacheMethodLookup.

	! !


Object subclass: #Test
	instanceVariableNames: 'name executionStopWatch methodLookupStrategy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Interpreter'!


!Test methodsFor: 'printing' stamp: 'HAW 7/10/2001 20:19'!
printAsCsvOn: aStream

	aStream 
		nextPutAll: self name;
		comma.

	self printExecutionTimeAsCsvOn: aStream.
	aStream comma.

	self methodLookupStrategy printAsCsvOn: aStream enclosedTime: (self normalizedExecutionTime).
! !

!Test methodsFor: 'printing' stamp: 'HAW 6/17/2001 23:50'!
printExecutionTimeAsCsvOn: aStream

	aStream 
		nextPutAll: self normalizedExecutionTime asMilliseconds valueAsString.! !

!Test methodsFor: 'printing' stamp: 'HAW 7/10/2001 11:31'!
printExecutionTimeOn: aStream

	aStream 
		nextPutAll: 'Tiempo Total de Ejecucin: ';
		nextPutAll: self normalizedExecutionTime asMilliseconds printString.
! !

!Test methodsFor: 'printing' stamp: 'HAW 6/12/2001 08:56'!
printOn: aStream

	aStream 
		nextPutAll: 'Nombre del Test: ';
		nextPutAll: self name;
		cr.

	self printExecutionTimeOn: aStream.
	aStream cr.

	self methodLookupStrategy printOn: aStream enclosedTime: (self normalizedExecutionTime).


! !


!Test methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:59'!
normalizedExecutionTime
 
	^self realExecutionTime - self methodLookupStrategy deviationTime.! !

!Test methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:57'!
realExecutionTime
 
	^self executionStopWatch expendedTime.! !

!Test methodsFor: 'profiling' stamp: 'HAW 6/13/2001 09:03'!
startProfiling

	StopWatch initializeTicksStack.
	self executionStopWatch: StopWatch new.
	self methodLookupStrategy startProfiling.
	self executionStopWatch start.
! !

!Test methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:56'!
stopProfiling

	self executionStopWatch stop.
	self methodLookupStrategy stopProfiling.! !


!Test methodsFor: 'access' stamp: 'HAW 12/12/2000 09:56'!
executionStopWatch

	^executionStopWatch! !

!Test methodsFor: 'access' stamp: 'HAW 12/12/2000 09:56'!
executionStopWatch: aStopWatch

	executionStopWatch _ aStopWatch.! !

!Test methodsFor: 'access' stamp: 'HAW 12/19/2000 08:40'!
methodLookupStrategy

	^methodLookupStrategy! !

!Test methodsFor: 'access' stamp: 'HAW 12/19/2000 08:40'!
methodLookupStrategy: aMethodLookupStrategy

	methodLookupStrategy _ aMethodLookupStrategy! !

!Test methodsFor: 'access' stamp: 'HAW 12/12/2000 09:47'!
name
	^name.! !

!Test methodsFor: 'access' stamp: 'HAW 12/12/2000 09:47'!
name: aName
	name _ aName.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

Test class
	instanceVariableNames: ''!

!Test class methodsFor: 'instance creation' stamp: 'HAW 12/19/2000 08:40'!
named: aName for: aMethodLookupStrategy

	^(super new)
		name: aName;
		methodLookupStrategy: aMethodLookupStrategy;
		yourself.! !

!Test class methodsFor: 'instance creation' stamp: 'HAW 12/19/2000 08:41'!
new

	^self error: 'Usar named:for:'! !
