Object subclass: #MethodLookupProfiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup Profiling'!

!MethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 5/3/2001 10:00'!
profileExtraTime: aBlock

	self subclassResponsibility.! !

!MethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/10/2000 09:42'!
profileMethodLookup: aBlock

	self subclassResponsibility.! !

!MethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/10/2000 09:41'!
selector: messageSelector sendTo: lookupClass

	self subclassResponsibility.! !

!MethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/10/2000 09:19'!
startProfiling

	self subclassResponsibility.! !

!MethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/10/2000 09:19'!
stopProfiling

	self subclassResponsibility.! !


!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:41'!
extraDeviationTime
	self subclassResponsibility! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 5/29/2001 11:02'!
extraTime
	self subclassResponsibility! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:41'!
methodLookupDeviationTime
	self subclassResponsibility! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/9/2000 08:56'!
methodLookupTime
	self subclassResponsibility! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:01'!
sendMessages
	self subclassResponsibility! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 09:11'!
totalDeviationTime

	^self extraTime + self extraDeviationTime + self methodLookupDeviationTime.
! !

!MethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 7/10/2001 12:09'!
totalExtraTime

	^self extraTime + self extraDeviationTime
! !


!MethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 6/13/2001 09:53'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	self subclassResponsibility.! !

!MethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 12/25/2000 09:16'!
printOn: aStream enclosedTime: aStopWatchTime

	self subclassResponsibility.! !


!MethodLookupProfiler methodsFor: 'initialization' stamp: 'HAW 12/10/2000 09:49'!
initialize

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

MethodLookupProfiler class
	instanceVariableNames: ''!

!MethodLookupProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/12/2000 10:18'!
new

	^super new
		initialize;
		yourself.! !


MethodLookupProfiler subclass: #BasicMethodLookupProfiler
	instanceVariableNames: 'totalSendMessages methodLookupStopWatch extraTimeStopWatch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup Profiling'!

!BasicMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:26'!
profileExtraTime: aBlock

	extraTimeStopWatch measure: aBlock.
! !

!BasicMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:27'!
profileMethodLookup: aBlock

	methodLookupStopWatch measure: aBlock.! !

!BasicMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/12/2000 10:16'!
selector: aSelector sendTo: aClass

	totalSendMessages _ totalSendMessages + 1.
! !

!BasicMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 6/8/2001 08:27'!
startProfiling

	methodLookupStopWatch clear.
	extraTimeStopWatch clear.

	! !

!BasicMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/12/2000 10:11'!
stopProfiling

	! !


!BasicMethodLookupProfiler methodsFor: 'initialization' stamp: 'HAW 6/8/2001 08:26'!
initialize

	totalSendMessages _ 0.
	methodLookupStopWatch _ StopWatch new.
	extraTimeStopWatch _ StopWatch new.! !


!BasicMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 7/10/2001 11:58'!
printMethodLookupTimeOn: aStream enclosedTime: aStopWatchTimeOrNil

	aStream nextPutAll: 'Tiempo de Method Lookup: '.
	self methodLookupTime asMilliseconds  printOn: aStream.
	aStopWatchTimeOrNil isNil ifFalse: [
		aStream 
			nextPutAll: '( ';
			nextPutAll: ((self methodLookupTime percentOf: aStopWatchTimeOrNil) roundTo: 0.01) printString;
			nextPutAll: '%)'. ].

! !

!BasicMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 6/8/2001 08:37'!
printOn: aStream

	^self printOn: aStream enclosedTime: nil.
! !

!BasicMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 6/9/2000 08:58'!
printOn: aStream enclosedTime: aStopWatchTime

	self printMethodLookupTimeOn: aStream enclosedTime: aStopWatchTime.
	aStream cr.
	self printSendMessagesOn: aStream.

! !

!BasicMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 6/12/2001 09:23'!
printSendMessagesOn: aStream

	aStream 
		nextPutAll: 'Total de mensajes buscados: ';
		nextPutAll: self sendMessages printString;
		cr.
! !


!BasicMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:32'!
extraDeviationTime

	^extraTimeStopWatch deviationTime.
! !

!BasicMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:28'!
extraTime

	^extraTimeStopWatch expendedTime.
! !

!BasicMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:32'!
methodLookupDeviationTime

	^methodLookupStopWatch deviationTime.
! !

!BasicMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/24/2001 22:27'!
methodLookupTime

	^methodLookupStopWatch expendedTime - (self extraTime + self extraDeviationTime ).
! !

!BasicMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:02'!
sendMessages

	^totalSendMessages! !


!BasicMethodLookupProfiler methodsFor: 'printing as Csv' stamp: 'HAW 6/17/2001 23:55'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	self printMethodLookupTimeAsCsvOn: aStream enclosedTime: aStopWatchTime.
	self printSendMessagesAsCsvOn: aStream.

! !

!BasicMethodLookupProfiler methodsFor: 'printing as Csv' stamp: 'HAW 6/17/2001 23:49'!
printMethodLookupTimeAsCsvOn: aStream enclosedTime: aStopWatchTimeOrNil

	aStream 
		nextPutAll: self methodLookupTime asMilliseconds valueAsString;
		comma.
	aStopWatchTimeOrNil isNil ifFalse: [
		aStream 
			nextPutAll: ((self methodLookupTime percentOf: aStopWatchTimeOrNil) roundTo: 0.01) printString;
			comma. ].

! !

!BasicMethodLookupProfiler methodsFor: 'printing as Csv' stamp: 'HAW 6/13/2001 09:57'!
printSendMessagesAsCsvOn: aStream

	aStream 
		nextPutAll: self sendMessages printString;
		comma.
! !


BasicMethodLookupProfiler subclass: #GlobalLookupCacheProfiler
	instanceVariableNames: 'methodLookup '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup Profiling'!

!GlobalLookupCacheProfiler methodsFor: 'printing' stamp: 'HAW 6/13/2001 09:54'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	super printOn: aStream enclosedTime: aStopWatchTime.
	aStream cr.
	self cachingStrategy profilingResult printOn: aStream enclosedTime: self methodLookupTime.
	aStream cr.

	aStream nextPutAll: 'Tiempo de Bsqueda usando DTS: '.
	(self methodLookupStrategy profilingResult methodLookupTime asMilliseconds value roundTo: 0.01) printOn: aStream.
	aStream 
		nextPutAll: '( ';
		nextPutAll: ((self methodLookupStrategy profilingResult methodLookupTime percentOf: (self methodLookupTime)) roundTo: 0.01) printString;
		nextPutAll: '%)'.
! !

!GlobalLookupCacheProfiler methodsFor: 'printing' stamp: 'HAW 1/8/2001 09:23'!
printOn: aStream

	super printOn: aStream.
	aStream cr.
	self methodLookupStrategy profilingResult printOn: aStream.
	aStream cr.
	self cachingStrategy profilingResult printOn: aStream.
! !

!GlobalLookupCacheProfiler methodsFor: 'printing' stamp: 'HAW 6/9/2000 08:57'!
printOn: aStream enclosedTime: aStopWatchTime

	super printOn: aStream enclosedTime: aStopWatchTime.
	aStream cr.
	self cachingStrategy profilingResult printOn: aStream enclosedTime: self methodLookupTime.
	aStream cr.

	aStream nextPutAll: 'Tiempo de Bsqueda usando DTS: '.
	(self methodLookupStrategy profilingResult methodLookupTime asMilliseconds value roundTo: 0.01) printOn: aStream.
	aStream 
		nextPutAll: '( ';
		nextPutAll: ((self methodLookupStrategy profilingResult methodLookupTime percentOf: (self methodLookupTime)) roundTo: 0.01) printString;
		nextPutAll: '%)'.
! !


!GlobalLookupCacheProfiler methodsFor: 'accessing' stamp: 'HAW 12/20/2000 09:51'!
cachingStrategy

	^self methodLookup cachingStrategy! !

!GlobalLookupCacheProfiler methodsFor: 'accessing' stamp: 'HAW 12/19/2000 09:36'!
methodLookup

	^methodLookup! !

!GlobalLookupCacheProfiler methodsFor: 'accessing' stamp: 'HAW 12/19/2000 09:37'!
methodLookup: aMethodLookup

	methodLookup _ aMethodLookup! !

!GlobalLookupCacheProfiler methodsFor: 'accessing' stamp: 'HAW 12/20/2000 09:51'!
methodLookupStrategy

	^self methodLookup methodLookupStrategy! !


!GlobalLookupCacheProfiler methodsFor: 'profiling' stamp: 'HAW 12/26/2000 09:44'!
startProfiling

	self methodLookupStrategy startProfiling.
	self cachingStrategy startProfiling.
	^super startProfiling.! !

!GlobalLookupCacheProfiler methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:52'!
stopProfiling

	self methodLookupStrategy stopProfiling.
	self cachingStrategy stopProfiling.
	^super stopProfiling.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

GlobalLookupCacheProfiler class
	instanceVariableNames: ''!

!GlobalLookupCacheProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/19/2000 09:35'!
on: aMethodLookup

	^(super new)
		methodLookup: aMethodLookup;
		yourself.! !


BasicMethodLookupProfiler subclass: #HierarchyBranchMLProfiler
	instanceVariableNames: 'tries '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup Profiling'!

!HierarchyBranchMLProfiler methodsFor: 'printing' stamp: 'HAW 6/10/2001 22:13'!
printOn: aStream enclosedTime: aTime

	super printOn: aStream enclosedTime: aTime.
! !


!HierarchyBranchMLProfiler methodsFor: 'initialization' stamp: 'HAW 6/10/2001 20:16'!
initialize

	super initialize.
	tries _ Dictionary new.! !


!HierarchyBranchMLProfiler methodsFor: 'profiling' stamp: 'HAW 6/10/2001 20:15'!
prolifeNumberOfTries: aNumberOfTries

	| currentTryCount |
	currentTryCount _ tries at: aNumberOfTries ifAbsent: [ tries at: aNumberOfTries put: 0 ].
	tries at: aNumberOfTries put: currentTryCount + 1.! !


MethodLookupProfiler subclass: #NullMethodLookupProfiler
	instanceVariableNames: ''
	classVariableNames: 'Singleton '
	poolDictionaries: ''
	category: 'Thesis-Method Lookup Profiling'!

!NullMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 5/3/2001 10:01'!
profileExtraTime: aBlock

	aBlock value.! !

!NullMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/11/2000 09:48'!
profileMethodLookup: aBlock

	aBlock value.! !

!NullMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/11/2000 09:21'!
selector: messageSelector sendTo: lookupClass
! !

!NullMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/11/2000 09:22'!
startProfiling! !

!NullMethodLookupProfiler methodsFor: 'profiling' stamp: 'HAW 12/11/2000 09:22'!
stopProfiling! !


!NullMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:40'!
extraDeviationTime

	^StopWatchTime cero.

! !

!NullMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 5/29/2001 11:02'!
extraTime

	^StopWatchTime cero.
! !

!NullMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/8/2001 08:40'!
methodLookupDeviationTime

	^StopWatchTime cero.
! !

!NullMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 6/9/2000 08:59'!
methodLookupTime

	^StopWatchTime cero.
! !

!NullMethodLookupProfiler methodsFor: 'accessing profiling results' stamp: 'HAW 12/20/2000 10:02'!
sendMessages

	^0.
! !


!NullMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 12/12/2000 10:20'!
printAsCsvOn: aStream


! !

!NullMethodLookupProfiler methodsFor: 'printing' stamp: 'HAW 12/25/2000 10:03'!
printOn: aStream enclosedTime: aStopWatchTime

	^self printOn: aStream.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

NullMethodLookupProfiler class
	instanceVariableNames: ''!

!NullMethodLookupProfiler class methodsFor: 'instance creation' stamp: 'HAW 12/12/2000 10:19'!
initializeSingleton
	Singleton _ super new.! !

!NullMethodLookupProfiler class methodsFor: 'instance creation' stamp: 'HAW 11/21/2000 08:59'!
new
	Singleton ifNil: [ self initializeSingleton.].
	^Singleton.! !
