Object subclass: #MethodLookupStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:30'!
createProfiler

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 6/8/2001 09:09'!
deviationTime

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 12:10'!
extraTime

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 6/8/2001 09:56'!
lookupTime

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:29'!
profiler

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:29'!
profiler: aProfiler

	self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:30'!
profilingResult

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:30'!
profilingResult: aProfiler

	self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:40'!
startProfiling

	self profiler: self createProfiler.
	self profiler startProfiling.! !

!MethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:40'!
stopProfiling

	self profiler stopProfiling.
	self profilingResult: self profiler.
	self profiler: NullMethodLookupProfiler new.

	^self profilingResult.! !


!MethodLookupStrategy methodsFor: 'caching' stamp: 'HAW 12/20/2000 09:31'!
flushCache

	^self subclassResponsibility.! !

!MethodLookupStrategy methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:11'!
primitiveFlushCacheByMethod

	^self subclassResponsibility.
! !

!MethodLookupStrategy methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:11'!
primitiveFlushCacheSelective

	^self subclassResponsibility.
! !


!MethodLookupStrategy methodsFor: 'interpreter access' stamp: 'HAW 12/20/2000 09:32'!
interpreter

	^self subclassResponsibility! !

!MethodLookupStrategy methodsFor: 'interpreter access' stamp: 'HAW 12/20/2000 09:33'!
interpreter: anInterpreter

	self subclassResponsibility! !


!MethodLookupStrategy methodsFor: 'method lookup interface' stamp: 'HAW 12/20/2000 09:32'!
findMethodForSelector: aSelector inClass: aClass 
	
	^self subclassResponsibility! !


!MethodLookupStrategy methodsFor: 'printing as Csv' stamp: 'HAW 6/13/2001 09:47'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	self printNameAsCsvOn: aStream.
	self printProfilingResultAsCsvOn: aStream enclosedTime: aStopWatchTime.
! !

!MethodLookupStrategy methodsFor: 'printing as Csv' stamp: 'HAW 6/13/2001 09:48'!
printNameAsCsvOn: aStream

	aStream 
		nextPutAll: self class name;
		comma.

! !

!MethodLookupStrategy methodsFor: 'printing as Csv' stamp: 'HAW 6/13/2001 09:48'!
printProfilingResultAsCsvOn: aStream enclosedTime: aStopWatchTime

	self profilingResult printAsCsvOn: aStream enclosedTime: aStopWatchTime.! !


!MethodLookupStrategy methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:41'!
printNameOn: aStream

	aStream 
		nextPutAll: 'Lookup Strategy: ';
		nextPutAll: self class name;
		cr.

! !

!MethodLookupStrategy methodsFor: 'printing' stamp: 'HAW 6/8/2001 09:43'!
printOn: aStream enclosedTime: aStopWatchTime

	self printNameOn: aStream.
	self printProfilingResultOn: aStream enclosedTime: aStopWatchTime.
! !

!MethodLookupStrategy methodsFor: 'printing' stamp: 'HAW 6/8/2001 10:18'!
printProfilingResultOn: aStream enclosedTime: aStopWatchTime

	self profilingResult printOn: aStream enclosedTime: aStopWatchTime.! !


!MethodLookupStrategy methodsFor: 'initialization' stamp: 'HAW 6/11/2001 02:23'!
performInitalization: selector with: parameter

	self subclassResponsibility.! !


MethodLookupStrategy subclass: #BasicMethodLookupStrategy
	instanceVariableNames: 'interpreter profiler profilingResult nilObj maxPrimitiveIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 6/8/2001 09:21'!
deviationTime
	
	^self profilingResult totalDeviationTime.
! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 7/10/2001 12:10'!
extraTime
	
	^self profilingResult totalExtraTime.
! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 6/11/2001 01:33'!
lookupTime
	
	^self profilingResult methodLookupTime.
! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 7/5/2001 08:31'!
profiler
	
	^profiler
! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 7/5/2001 08:32'!
profiler: aMethodLookupProfiler

	profiler _ aMethodLookupProfiler

! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:34'!
profilingResult
	
	^profilingResult
! !

!BasicMethodLookupStrategy methodsFor: 'profiling' stamp: 'HAW 12/20/2000 09:34'!
profilingResult: aProfiler
	
	profilingResult _ aProfiler
! !


!BasicMethodLookupStrategy methodsFor: 'method lookup implementation' stamp: 'HAW 8/23/2001 08:59'!
lookupMethodForSelector: aSelector inClass: aClass

	self subclassResponsibility.! !


!BasicMethodLookupStrategy methodsFor: 'method lookup interface' stamp: 'HAW 7/5/2001 08:41'!
findMethodForSelector: aSelector inClass: aClass 

	"Uses the template pattern.
	Subclasses must implement lookupMethodForSelector: inClass:"

	| result |

	profiler selector: aSelector sendTo: aClass.
	profiler profileMethodLookup: [ result _ self lookupMethodForSelector: aSelector inClass: aClass ].
	^result.
! !


!BasicMethodLookupStrategy methodsFor: 'interpreter access' stamp: 'HAW 8/4/2000 10:05'!
interpreter

	^interpreter! !

!BasicMethodLookupStrategy methodsFor: 'interpreter access' stamp: 'HAW 6/10/2001 22:48'!
interpreter: anInterpreter

	interpreter _ anInterpreter.
	self initializeInterpreterData.! !


!BasicMethodLookupStrategy methodsFor: 'initialization' stamp: 'HAW 7/5/2001 08:32'!
initialize

	profiler _ NullMethodLookupProfiler new.
! !

!BasicMethodLookupStrategy methodsFor: 'initialization' stamp: 'HAW 6/10/2001 22:48'!
initializeInterpreterData

	nilObj _ interpreter nilObject.
	maxPrimitiveIndex _ interpreter maxPrimitiveIndex.! !

!BasicMethodLookupStrategy methodsFor: 'initialization' stamp: 'HAW 6/11/2001 02:24'!
performInitalization: aSelector with: aCollaborator

	self perform: aSelector with: aCollaborator.! !


!BasicMethodLookupStrategy methodsFor: 'dictionary support' stamp: 'HAW 6/10/2001 22:55'!
lookupInteger: anInteger inDictionary: aDictionary

	| array arraySize association key hash start |

	"Fetchs the inst. vars array"
	array _ interpreter fetchPointer: 1 ofObject: aDictionary.

	hash _ interpreter integerValueOf: anInteger.
	arraySize _ interpreter fetchWordLengthOf: array.
	arraySize > 4096 ifTrue:
		[ hash _ hash * (arraySize//4096)].

	start _ hash \\ arraySize.
	start to: arraySize-1 do:
		[ :index |
		association _ interpreter fetchPointer: index ofObject: array.
		association=nilObj ifTrue: 
			[^ nilObj ]
		ifFalse:
			[key _ interpreter fetchPointer: 0 ofObject: association.
			key=anInteger ifTrue:
				[^ interpreter fetchPointer: 1 ofObject: association. ].
			].
		].

	0 to: start-1 do:
		[ :index |
		association _ interpreter fetchPointer: index ofObject: array.
		association=nilObj ifTrue: 
			[^ nilObj ]
		ifFalse:
			[key _ interpreter fetchPointer: 0 ofObject: association.
			key=anInteger ifTrue:
				[^ interpreter fetchPointer: 1 ofObject: association. ].
			].
		].

	^ nilObj.

! !

!BasicMethodLookupStrategy methodsFor: 'dictionary support' stamp: 'HAW 6/10/2001 22:54'!
lookupObject: anObject inDictionary: aDictionary

	| array arraySize association key hash start |

	"Fetchs the inst. vars array"
	array _ interpreter fetchPointer: 1 ofObject: aDictionary.

	hash _ interpreter hashBitsOf: anObject.
	arraySize _ interpreter fetchWordLengthOf: array.
	arraySize > 4096 ifTrue:
		[ hash _ hash * (arraySize//4096)].

	start _ hash \\ arraySize.
	start to: arraySize-1 do:
		[ :index |
		association _ interpreter fetchPointer: index ofObject: array.
		association=nilObj ifTrue: 
			[^ nilObj ]
		ifFalse:
			[key _ interpreter fetchPointer: 0 ofObject: association.
			key=anObject ifTrue:
				[^ interpreter fetchPointer: 1 ofObject: association. ].
			].
		].

	0 to: start-1 do:
		[ :index |
		association _ interpreter fetchPointer: index ofObject: array.
		association=nilObj ifTrue: 
			[^ nilObj ]
		ifFalse:
			[key _ interpreter fetchPointer: 0 ofObject: association.
			key=anObject ifTrue:
				[^ interpreter fetchPointer: 1 ofObject: association. ].
			].
		].

	^ nilObj.

! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

BasicMethodLookupStrategy class
	instanceVariableNames: ''!

!BasicMethodLookupStrategy class methodsFor: 'instance creation' stamp: 'HAW 6/10/2001 22:47'!
on: anInterpreter

	^super new
		interpreter: anInterpreter;
		initialize;
		yourself.! !


BasicMethodLookupStrategy subclass: #CachedMethodLookup
	instanceVariableNames: 'cachingStrategy methodLookupStrategy '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!CachedMethodLookup methodsFor: 'strategies' stamp: 'HAW 12/5/2000 10:02'!
cachingStrategy
	^cachingStrategy! !

!CachedMethodLookup methodsFor: 'strategies' stamp: 'HAW 12/5/2000 10:02'!
cachingStrategy: aCachingStrategy
	cachingStrategy _ aCachingStrategy.! !

!CachedMethodLookup methodsFor: 'strategies' stamp: 'HAW 12/5/2000 10:12'!
methodLookupStrategy
	^methodLookupStrategy! !

!CachedMethodLookup methodsFor: 'strategies' stamp: 'HAW 12/5/2000 10:13'!
methodLookupStrategy: aMethodLookupStrategy
	methodLookupStrategy _ aMethodLookupStrategy.! !


!CachedMethodLookup methodsFor: 'method lookup implementation' stamp: 'HAW 7/10/2001 10:43'!
lookupMethodForSelector: aSelector inClass: aClass

	| foundOnCache |
 
	foundOnCache _ cachingStrategy findMethodForSelector: aSelector inClass: aClass.
	foundOnCache ifFalse: [
		methodLookupStrategy findMethodForSelector: aSelector inClass: aClass.
		cachingStrategy addSelector: aSelector forClass: aClass 
			method: (interpreter newMethod) primitiveIndex: (interpreter primitiveIndex).
	].
! !


!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 7/5/2001 09:48'!
cacheLookupTime

	^self cachingStrategy lookupCacheTime.
! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/8/2001 10:00'!
cacheMaintenanceTime

	^self cachingStrategy maintenanceTime.
! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/16/2001 10:40'!
createProfiler

	^BasicMethodLookupProfiler new.
! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/16/2001 09:04'!
deviationTime

	^self profilingResult totalDeviationTime + self methodLookupStrategy deviationTime + self cachingStrategy deviationTime.
! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/16/2001 08:59'!
lookupTime

	^self profilingResult methodLookupTime - self methodLookupStrategy deviationTime - self cachingStrategy deviationTime.
! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/16/2001 10:39'!
startProfiling

	super startProfiling.
	self methodLookupStrategy startProfiling.
	self cachingStrategy startProfiling.! !

!CachedMethodLookup methodsFor: 'profiling' stamp: 'HAW 6/16/2001 10:40'!
stopProfiling

	super stopProfiling.
	self methodLookupStrategy stopProfiling.
	self cachingStrategy stopProfiling.! !


!CachedMethodLookup methodsFor: 'test' stamp: 'HAW 5/10/2001 08:44'!
testInit: aStringPointer

	Transcript show: (self interpreter stringOf: aStringPointer).! !


!CachedMethodLookup methodsFor: 'caching' stamp: 'HAW 1/9/2001 08:31'!
flushCache

	cachingStrategy flushCache.! !

!CachedMethodLookup methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:13'!
primitiveFlushCacheByMethod

	cachingStrategy primitiveFlushCacheByMethod.! !

!CachedMethodLookup methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:13'!
primitiveFlushCacheSelective

	cachingStrategy primitiveFlushCacheSelective.! !


!CachedMethodLookup methodsFor: 'printing as Csv' stamp: 'HAW 6/24/2001 23:20'!
printAsCsvOn: aStream enclosedTime: aStopWatchTime

	super printNameAsCsvOn: aStream.
	self printResultAsCsvOn: aStream enclosedTime: aStopWatchTime.
	self printMethodLookupStrategyAsCsvOn: aStream.
	self printCachingStrategyAsCsvOn: aStream.! !

!CachedMethodLookup methodsFor: 'printing as Csv' stamp: 'HAW 7/5/2001 09:49'!
printCachingStrategyAsCsvOn: aStream 

	self cachingStrategy printAsCsvOn: aStream enclosedTime: self lookupTime.! !

!CachedMethodLookup methodsFor: 'printing as Csv' stamp: 'HAW 7/5/2001 09:49'!
printMethodLookupStrategyAsCsvOn: aStream 

	self methodLookupStrategy printAsCsvOn: aStream enclosedTime: (self lookupTime + self methodLookupStrategy deviationTime)

! !

!CachedMethodLookup methodsFor: 'printing as Csv' stamp: 'HAW 6/17/2001 23:49'!
printResultAsCsvOn: aStream enclosedTime: aStopWatchTime

	aStream 
		nextPutAll: self lookupTime asMilliseconds valueAsString;
		comma;
		nextPutAll: ((self lookupTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		comma.
	
		! !


!CachedMethodLookup methodsFor: 'printing' stamp: 'HAW 7/5/2001 09:49'!
printCachingStrategyOn: aStream 

	self cachingStrategy printOn: aStream enclosedTime: self lookupTime.! !

!CachedMethodLookup methodsFor: 'printing' stamp: 'HAW 6/24/2001 22:46'!
printMethodLookupStrategyOn: aStream 

	self methodLookupStrategy printOn: aStream enclosedTime: (self lookupTime + self methodLookupStrategy deviationTime)
! !

!CachedMethodLookup methodsFor: 'printing' stamp: 'HAW 6/24/2001 23:19'!
printOn: aStream enclosedTime: aStopWatchTime

	super printNameOn: aStream.
	self printResultOn: aStream enclosedTime: aStopWatchTime.
	self printMethodLookupStrategyOn: aStream.
	self printCachingStrategyOn: aStream.
! !

!CachedMethodLookup methodsFor: 'printing' stamp: 'HAW 6/16/2001 09:08'!
printResultOn: aStream enclosedTime: aStopWatchTime
 
	aStream 
		nextPutAll: 'Tiempo total de Lookup: ';
		nextPutAll: self lookupTime asMilliseconds printString;
		nextPutAll: ' (';
		nextPutAll: ((self lookupTime percentOf: aStopWatchTime) roundTo: 0.01) printString;
		nextPutAll: '%)';
		cr.
	
		
! !


!CachedMethodLookup methodsFor: 'initialization' stamp: 'HAW 6/12/2001 10:29'!
performCacheInitalization: aSelector with: aCollaborator

	self cachingStrategy perform: aSelector with: aCollaborator.! !

!CachedMethodLookup methodsFor: 'initialization' stamp: 'HAW 6/12/2001 10:29'!
performInitalization: aSelector with: aCollaborator

	self methodLookupStrategy perform: aSelector with: aCollaborator.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

CachedMethodLookup class
	instanceVariableNames: ''!

!CachedMethodLookup class methodsFor: 'instance creation' stamp: 'HAW 6/11/2001 01:47'!
defaultCachingCreationBlock

	^[ :anInterpreter | GlobalCachingStrategy on: anInterpreter ].

! !

!CachedMethodLookup class methodsFor: 'instance creation' stamp: 'HAW 6/11/2001 01:47'!
defaultMLCreationBlock

	^[ :anInterpreter | DispatchTableSearchML on: anInterpreter ].

! !

!CachedMethodLookup class methodsFor: 'instance creation' stamp: 'HAW 6/11/2001 01:48'!
on: anInterpreter

	^self on: anInterpreter methodLookupCreationBlock: self defaultMLCreationBlock.! !

!CachedMethodLookup class methodsFor: 'instance creation' stamp: 'HAW 6/11/2001 02:18'!
on: anInterpreter methodLookupCreationBlock: aMLCreationBlock

	^self 
		on: anInterpreter
		methodLookupCreationBlock: aMLCreationBlock 
		cachingCreationBlock: self defaultCachingCreationBlock.

! !

!CachedMethodLookup class methodsFor: 'instance creation' stamp: 'HAW 6/11/2001 01:45'!
on: anInterpreter methodLookupCreationBlock: aMLCreationBlock cachingCreationBlock: aCachingCreationBlock

	^(super on: anInterpreter)
		methodLookupStrategy: (aMLCreationBlock value: anInterpreter);
		cachingStrategy: (aCachingCreationBlock value: anInterpreter );
		yourself.! !


BasicMethodLookupStrategy subclass: #DTSWithClassesML
	instanceVariableNames: 'selectorsDictionary '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!DTSWithClassesML methodsFor: 'initialization' stamp: 'HAW 5/10/2001 09:12'!
selectorsDictionary: anDictionaryPointer
	"This message is sent to set the reference to the dictionary that holds the DTS information"

	selectorsDictionary _ anDictionaryPointer
	! !


!DTSWithClassesML methodsFor: 'method lookup implementation' stamp: 'HAW 7/11/2001 09:34'!
lookupMethodForSelector: aSelector inClass: aClass

	| selectorDictionary result |

	profiler profileExtraTime: [ selectorDictionary _ self selectorDictionaryFor: aSelector ].
	result _ self lookupMethodInDictionary: selectorDictionary forClass: aClass.

	^result
! !

!DTSWithClassesML methodsFor: 'method lookup implementation' stamp: 'HAW 7/5/2001 08:40'!
lookupMethodInDictionary: selectorDictionary forClass: class

	| currentClass newMethod rclass |

	currentClass _ class.
	[currentClass ~= nilObj] whileTrue:
		[newMethod _ self lookupObject: currentClass inDictionary: selectorDictionary.
		newMethod=nilObj ifFalse:
			[interpreter newMethod: newMethod.
			^newMethod].
		currentClass _ interpreter superclassOf: currentClass].

	"Could not find #doesNotUnderstand: -- unrecoverable error."
	interpreter messageSelector = interpreter selectorDoesNotUnderstand ifTrue:
	[self error: 'Recursive not understood error encountered'].

	"Cound not find a normal message -- raise exception #doesNotUnderstand:"
	interpreter pushRemappableOop: class.  "may cause GC!!"
	interpreter createActualMessageTo: class.
	rclass _ interpreter popRemappableOop.
	interpreter messageSelector: self selectorDoesNotUnderstand.
	^ self lookupMethodInDictionary: selectorDictionary forClass: rclass.
! !

!DTSWithClassesML methodsFor: 'method lookup implementation' stamp: 'HAW 6/10/2001 23:36'!
selectorDictionaryFor: aSelector

	^self lookupObject: aSelector inDictionary: selectorsDictionary.! !


!DTSWithClassesML methodsFor: 'caching' stamp: 'HAW 6/13/2001 08:58'!
flushCache

	"Do nothing. I don't have cache..."! !

!DTSWithClassesML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:13'!
primitiveFlushCacheByMethod

	"Do nothing. I don't have cache..."! !

!DTSWithClassesML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:13'!
primitiveFlushCacheSelective

	"Do nothing. I don't have cache..."! !


!DTSWithClassesML methodsFor: 'profiling' stamp: 'HAW 6/10/2001 23:40'!
createProfiler

	^BasicMethodLookupProfiler new.! !


BasicMethodLookupStrategy subclass: #DispatchTableSearchML
	instanceVariableNames: 'messageDictionaryIndex selectorStart methodArrayIndex '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!DispatchTableSearchML methodsFor: 'method lookup implementation' stamp: 'HAW 6/11/2001 00:39'!
lookupMethod: aSelector inDictionary: dictionary
	"This method lookup tolerates integers as Dictionary keys to support
	execution of images in which Symbols have been compacted out"
 	| length index mask wrapAround nextSelector methodArray |

	length _ interpreter fetchWordLengthOf: dictionary.
	mask _ length - selectorStart - 1.
	(interpreter isIntegerObject: aSelector)
		ifTrue:
		[index _ (mask bitAnd: (interpreter integerValueOf: aSelector)) + selectorStart]
		ifFalse:
		[index _ (mask bitAnd: (interpreter hashBitsOf: aSelector)) + selectorStart].
	"It is assumed that there are some nils in this dictionary, and search will
	stop when one is encountered.  However, if there are no nils, then wrapAround
	will be detected the second time the loop gets to the end of the table."
	wrapAround _ false.
	[true] whileTrue:
		[nextSelector _ interpreter fetchPointer: index
					ofObject: dictionary.
		nextSelector=nilObj ifTrue: [^false].
		nextSelector=aSelector
			ifTrue: [methodArray _ interpreter fetchPointer: methodArrayIndex
							ofObject: dictionary.
				interpreter newMethod: ( interpreter fetchPointer:  index - selectorStart
							ofObject: methodArray).
				^ true].
		index _ index + 1.
		index = length
			ifTrue: [wrapAround ifTrue: [^false].
				wrapAround _ true.
				index _ selectorStart]]! !

!DispatchTableSearchML methodsFor: 'method lookup implementation' stamp: 'HAW 8/21/2001 15:26'!
lookupMethodForSelector: aSelector inClass: aClass

	| currentClass dictionary found rclass |

	currentClass _ aClass.
	[currentClass ~= nilObj]
		whileTrue:
		[dictionary _ interpreter fetchPointer: messageDictionaryIndex ofObject: currentClass.
		found _ self lookupMethod: aSelector inDictionary: dictionary.
		found ifTrue: [^ currentClass].
		currentClass _ interpreter superclassOf: currentClass].

	"Could not find #doesNotUnderstand: -- unrecoverable error."
	aSelector= interpreter selectorDoesNotUnderstand ifTrue:
		[self error: 'Recursive not understood error encountered'].

	"Cound not find a normal message -- raise exception #doesNotUnderstand:"
	interpreter pushRemappableOop: aClass.  "may cause GC!!"
	interpreter createActualMessageTo: aClass.
	rclass _ interpreter popRemappableOop.
	^ self lookupMethodForSelector: (interpreter selectorDoesNotUnderstand) inClass: rclass.
! !


!DispatchTableSearchML methodsFor: 'profiling' stamp: 'HAW 12/19/2000 08:45'!
createProfiler

	^BasicMethodLookupProfiler new.! !


!DispatchTableSearchML methodsFor: 'caching' stamp: 'HAW 6/13/2001 08:58'!
flushCache

	"Do nothing. I don't have cache..."! !

!DispatchTableSearchML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:14'!
primitiveFlushCacheByMethod

	"Do nothing. I don't have cache..."! !

!DispatchTableSearchML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:13'!
primitiveFlushCacheSelective

	"Do nothing. I don't have cache..."! !


!DispatchTableSearchML methodsFor: 'initialization' stamp: 'HAW 6/13/2001 08:31'!
initializeInterpreterData

	super initializeInterpreterData.
	messageDictionaryIndex _ interpreter messageDictionaryIndex.
	selectorStart _ interpreter selectorStart.
	methodArrayIndex _ interpreter methodArrayIndex.! !


DispatchTableSearchML subclass: #FullDictionaryML
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!FullDictionaryML methodsFor: 'method lookup implementation' stamp: 'HAW 8/21/2001 15:34'!
lookupMethodForSelector: aSelector inClass: aClass

	"I have no diference with DTS..."
	^super lookupMethodForSelector: aSelector inClass: aClass.! !


BasicMethodLookupStrategy subclass: #HierarchyBranchML
	instanceVariableNames: 'classIntervals selectorsImplementations lastMessageImplementationBranch '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!HierarchyBranchML methodsFor: 'class numbers' stamp: 'HAW 6/10/2001 23:47'!
classIntervalFor: aBehavior

	^self lookupObject: aBehavior inDictionary: classIntervals.
! !

!HierarchyBranchML methodsFor: 'class numbers' stamp: 'HAW 5/25/2001 09:10'!
classNumberFor: aBehavior

	| classInterval |
	classInterval _ self classIntervalFor: aBehavior.
	^interpreter fetchInteger: 0 ofObject: classInterval.! !

!HierarchyBranchML methodsFor: 'class numbers' stamp: 'HAW 7/10/2001 15:46'!
lastFrom

	^interpreter fetchInteger: 0 ofObject: lastMessageImplementationBranch.! !

!HierarchyBranchML methodsFor: 'class numbers' stamp: 'HAW 7/10/2001 15:45'!
lastTo

	^interpreter fetchInteger: 1 ofObject: lastMessageImplementationBranch.! !


!HierarchyBranchML methodsFor: 'initialization' stamp: 'HAW 5/12/2001 09:37'!
classIntervals: aDictionaryPointer

	classIntervals _ aDictionaryPointer! !

!HierarchyBranchML methodsFor: 'initialization' stamp: 'HAW 5/29/2001 09:37'!
selectorsImplementations: aDictionaryPointer

	selectorsImplementations _ aDictionaryPointer.! !


!HierarchyBranchML methodsFor: 'selector implementations' stamp: 'HAW 6/10/2001 23:47'!
selectorImplementationsFor: aSelector

	^self lookupObject: aSelector inDictionary: selectorsImplementations.
! !


!HierarchyBranchML methodsFor: 'method lookup implementation' stamp: 'HAW 8/11/2001 10:43'!
compiledMethodFor: aClassNumber selectorImplementations: aSortedCollectionPointer

	"Implements the quick search algorithm"

	| array low mid high messageImplementationBranch |

	array _ interpreter fetchPointer: 0 ofObject: aSortedCollectionPointer. "Fetchs the array instVar"
	low _ (interpreter fetchInteger: 1 ofObject: aSortedCollectionPointer)-1. "Fetchs the firstIndex instVar"
	high _ (interpreter fetchInteger: 2 ofObject: aSortedCollectionPointer)-1. "Fetch the lastIndex instVar"
	[low <= high] whileTrue:
		[mid _ low + high // 2.
		messageImplementationBranch _ interpreter fetchPointer: mid ofObject: array.
		(interpreter fetchInteger:0 ofObject: messageImplementationBranch) <= aClassNumber ifTrue: [
			(interpreter fetchInteger:1 ofObject: messageImplementationBranch) > aClassNumber ifTrue: [
				"I save the branch to allow use it with out looking for it again"
				lastMessageImplementationBranch _ messageImplementationBranch.
				^(interpreter fetchPointer:2 ofObject: messageImplementationBranch) ]
			ifFalse: [
				low _ mid + 1.]. ]
		ifFalse: [
			high _ mid - 1.].
		].

	"No definition found, return nil"
	^nilObj.


! !

!HierarchyBranchML methodsFor: 'method lookup implementation' stamp: 'HAW 7/10/2001 15:42'!
lookupMethodForSelector: aSelector inClass: aClass

	| selectorImplementations classNumber result |

	profiler profileExtraTime: [ 
		selectorImplementations _ self selectorImplementationsFor: aSelector.
		classNumber _ self classNumberFor: aClass. ].

	result _ self compiledMethodFor: classNumber selectorImplementations: selectorImplementations.

	result=nilObj ifTrue: [ 
		profiler profileExtraTime: [
			selectorImplementations _ self selectorImplementationsFor: interpreter selectorDoesNotUnderstand.].
		result _ self compiledMethodFor: classNumber selectorImplementations: selectorImplementations.
		(result=interpreter nilObject) ifTrue: [ self error: 'MNU no implementado'.].].

	interpreter newMethod: result.

	^result.
! !


!HierarchyBranchML methodsFor: 'profiling' stamp: 'HAW 5/25/2001 09:05'!
createProfiler

	^BasicMethodLookupProfiler new.! !


!HierarchyBranchML methodsFor: 'caching' stamp: 'HAW 6/13/2001 08:58'!
flushCache

	"Do nothing. I don't have cache..."! !

!HierarchyBranchML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:14'!
primitiveFlushCacheByMethod

	"Do nothing. I don't have cache..."! !

!HierarchyBranchML methodsFor: 'caching' stamp: 'HAW 6/12/2001 10:14'!
primitiveFlushCacheSelective

	"Do nothing. I don't have cache..."! !


HierarchyBranchML subclass: #HierarchyBranchWithDicML
	instanceVariableNames: 'sortedCollection '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Method Lookup strategies'!

!HierarchyBranchWithDicML methodsFor: 'initialization' stamp: 'HAW 5/29/2001 14:35'!
sortedCollection: aClassPointer

	sortedCollection _ aClassPointer! !


!HierarchyBranchWithDicML methodsFor: 'method lookup implementation' stamp: 'HAW 6/26/2001 10:04'!
for1compiledMethodFor: aClassNumber selectorImplementations: aSortedCollectionPointer

	"Just for collections of 1 element"

	| array low messageImplementationBranch |

	array _ interpreter fetchPointer: 0 ofObject: aSortedCollectionPointer. "Fetchs the array instVar"
	low _ (interpreter fetchInteger: 1 ofObject: aSortedCollectionPointer)-1.
	messageImplementationBranch _ interpreter fetchPointer: low ofObject: array.
	^(interpreter fetchPointer:2 ofObject: messageImplementationBranch).

! !

!HierarchyBranchWithDicML methodsFor: 'method lookup implementation' stamp: 'HAW 8/11/2001 11:01'!
lookupMethodForSelector: aSelector inClass: aClass

	"I reimplemented the method to have a better performance" 

	| selectorImplementations classNumber result doesNotUnderstand |
 
	profiler profileExtraTime: [ 
		selectorImplementations _ self selectorImplementationsFor: aSelector. ].

	"I check if the implementation is a sorted collection or a dictionary"
	(interpreter fetchClassOf: selectorImplementations)=sortedCollection ifTrue: [
		profiler profileExtraTime: [ classNumber _ self classNumberFor: aClass. ].
		result _ self compiledMethodFor: classNumber selectorImplementations: selectorImplementations. ]
	ifFalse: [
		result _self lookupObject: aClass inDictionary: selectorImplementations. ].

	result=nilObj ifTrue: [ 
"		I have commented this because it assumes that are all messages are stored in SortedCollections	
		profiler profileExtraTime: [
			selectorImplementations _ self selectorImplementationsFor: interpreter selectorDoesNotUnderstand.
			classNumber isNil ifTrue: [ classNumber _ self classNumberFor: aClass. ]. ].
		result _ self compiledMethodFor: classNumber selectorImplementations: selectorImplementations.
		(result=interpreter nilObject) ifTrue: [ self error: 'MNU no implementado'.]."
		doesNotUnderstand _ interpreter selectorDoesNotUnderstand.
		aSelector=doesNotUnderstand ifTrue: [ self error: 'MNU no implementado'.].
		result _ self lookupMethodForSelector: doesNotUnderstand inClass: aClass.
	].
 
	interpreter newMethod: result.

	^result
! !
