Object subclass: #StopWatch
	instanceVariableNames: 'totalTicks numberOfMeasurements '
	classVariableNames: 'MeasurementDeviation TicksPerSecond '
	poolDictionaries: ''
	category: 'Thesis-Profiling support'!

!StopWatch methodsFor: 'private' stamp: 'HAW 10/30/2000 09:33'!
currentTicks

	<primitive: 600>! !

!StopWatch methodsFor: 'private' stamp: 'HAW 6/6/2001 09:16'!
elapsedTicks

	<primitive: 603>! !

!StopWatch methodsFor: 'private' stamp: 'HAW 6/6/2001 09:16'!
saveCurrentTicks

	<primitive: 602>! !


!StopWatch methodsFor: 'printing' stamp: 'HAW 6/24/2001 21:49'!
printOn: aStream

	aStream 
		nextPutAll: self expendedTime asMilliseconds printString;
		cr;
		nextPutAll: self totalExpendedTime asMilliseconds printString.! !


!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/6/2001 09:08'!
clear

	self initialize.! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/8/2001 08:22'!
deviationTime

	^StopWatchTicks new:  (self class measurementDeviation * numberOfMeasurements).! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 12/11/2000 09:06'!
expendedMilliseconds

	^self expendedTime asMilliseconds
! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 12/11/2000 09:06'!
expendedSeconds

	^self expendedTime asSeconds.
! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 12/11/2000 09:06'!
expendedTicks

	^self expendedTime asTicks.! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/8/2001 08:22'!
expendedTime

	^StopWatchTicks new: totalTicks.! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/8/2001 08:48'!
measure: aBlock

	self start.
	aBlock value.
	^self stop.

! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/8/2001 08:23'!
start

	self saveCurrentTicks.
	! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 7/10/2001 20:25'!
stop

	| elapsedTicks |

	elapsedTicks _ self elapsedTicks.
	totalTicks _ totalTicks + elapsedTicks.
	numberOfMeasurements _ numberOfMeasurements + 1.
	^elapsedTicks.
! !

!StopWatch methodsFor: 'measuring' stamp: 'HAW 6/24/2001 21:47'!
totalExpendedTime

	^self expendedTime + self deviationTime.
! !


!StopWatch methodsFor: 'initialization' stamp: 'HAW 6/6/2001 09:25'!
initialize

	totalTicks _ 0.
	numberOfMeasurements _ 0.
	! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StopWatch class
	instanceVariableNames: ''!

!StopWatch class methodsFor: 'ticks information' stamp: 'HAW 10/30/2000 09:13'!
ticksPerMillisecond

	^self ticksPerSecond / 1000! !

!StopWatch class methodsFor: 'ticks information' stamp: 'HAW 10/30/2000 09:12'!
ticksPerSecond

	^TicksPerSecond! !


!StopWatch class methodsFor: 'test' stamp: 'HAW 6/24/2001 21:51'!
testComposite

	| sum sw1 sw2 sw3 |

	sw1 _ StopWatch new.
	sw2 _ StopWatch new.
	sw3 _ StopWatch new.

	sw1 measure: [
		sum _ 0.
		1 to: 1000 do: [ :index |
			sum _ sum + 1. ].
	].
	sw1 clear.

	sw3 measure: [
	sw1 measure: [
		sum _ 0.
		1 to: 1000 do: [ :index |
			sum _ sum + 1. ].
	].

	sw2 measure: [
		sum _ 0.
		1 to: 1000 do: [ :index |
			sum _ sum + 1. ].
	].
	].
	self halt.
	^Array 
		with: sw3 expendedTime value
		with: sw1 totalExpendedTime value asFloat
		with: sw2 totalExpendedTime value asFloat
		with: (sw3 expendedTime - sw1 totalExpendedTime - sw2 totalExpendedTime) value asFloat.
! !


!StopWatch class methodsFor: 'initialize' stamp: 'HAW 10/30/2000 09:33'!
basicTicksPerSecond

	<primitive: 601>! !

!StopWatch class methodsFor: 'initialize' stamp: 'HAW 6/6/2001 09:45'!
initialize

	self initializeTicksPerSecond.
	self initializeMeasurementDeviation.! !

!StopWatch class methodsFor: 'initialize' stamp: 'HAW 6/6/2001 09:46'!
initializeMeasurementDeviation

	MeasurementDeviation _ self calculateMeasurementDeviation.! !

!StopWatch class methodsFor: 'initialize' stamp: 'HAW 10/30/2000 09:06'!
initializeTicksPerSecond

	TicksPerSecond := self basicTicksPerSecond.! !


!StopWatch class methodsFor: 'instance creation' stamp: 'HAW 10/30/2000 09:14'!
new

	^super new initialize.! !


!StopWatch class methodsFor: 'measure deviation' stamp: 'HAW 6/6/2001 09:53'!
calculateMeasurementDeviation

	| ticksMeasuring tickWithOutMeasuring |

	ticksMeasuring _ self ticksMeasuring.
	tickWithOutMeasuring _ self ticksWithOutMeasuring.

	^(ticksMeasuring - tickWithOutMeasuring)/self cyclesForDeviation.! !

!StopWatch class methodsFor: 'measure deviation' stamp: 'HAW 6/6/2001 09:52'!
cyclesForDeviation

	^ 200.! !

!StopWatch class methodsFor: 'measure deviation' stamp: 'HAW 6/6/2001 09:59'!
measurementDeviation

	^MeasurementDeviation.! !

!StopWatch class methodsFor: 'measure deviation' stamp: 'HAW 6/6/2001 09:52'!
ticksMeasuring

	| coll stopWatch |
	coll _ OrderedCollection new.
	stopWatch _ StopWatch new.
	1 to: self cyclesForDeviation do: [ :j |
		coll add: ( StopWatch ticksToRun: [ 1 to: 100 do: [ :i |  
			stopWatch measure: [ 2 + 2 ]. ]. ]).
	].
	^coll average.
! !

!StopWatch class methodsFor: 'measure deviation' stamp: 'HAW 6/6/2001 09:52'!
ticksWithOutMeasuring

	| coll |
	coll _ OrderedCollection new.
	1 to: self cyclesForDeviation do: [ :j |
		coll add: ( StopWatch ticksToRun: [ 1 to: 100 do: [ : i | 2 + 2 ].]).
	].
	^coll average.! !


!StopWatch class methodsFor: 'measure' stamp: 'HAW 1/8/2001 08:49'!
elapsedTicks

	<primitive: 603>! !

!StopWatch class methodsFor: 'measure' stamp: 'HAW 1/8/2001 08:49'!
initializeTicksStack

	<primitive: 604>! !

!StopWatch class methodsFor: 'measure' stamp: 'HAW 1/8/2001 08:48'!
saveCurrentTicks

	<primitive: 602>! !

!StopWatch class methodsFor: 'measure' stamp: 'HAW 1/8/2001 09:27'!
ticksToRun: aBlock

	StopWatch saveCurrentTicks.
	aBlock value.
	^StopWatch elapsedTicks.
! !

!StopWatch class methodsFor: 'measure' stamp: 'HAW 1/8/2001 09:27'!
timeToRun: aBlock

	^StopWatchTicks new: (StopWatch ticksToRun: aBlock).
! !


StopWatch initialize!


Object subclass: #StopWatchTime
	instanceVariableNames: ''
	classVariableNames: 'Cero '
	poolDictionaries: ''
	category: 'Thesis-Profiling support'!

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:23'!
* aStopWatchTimeOrANumber

	^aStopWatchTimeOrANumber multiplyStopWatchTime: self.

! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/10/2000 10:39'!
+ aStopWatchTime

	self subclassResponsibility.! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 5/29/2001 11:05'!
- aStopWatchTime

	self subclassResponsibility.! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:24'!
/ aStopWatchTimeOrANumber

	^aStopWatchTimeOrANumber divideStopWatchTime: self.
! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:29'!
divideByANumber: aNumber

	self subclassResponsibility

! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:24'!
divideStopWatchTime: aStopWatchTime

	self subclassResponsibility

! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:29'!
multiplyByANumber: aNumber

	self subclassResponsibility

! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:23'!
multiplyStopWatchTime: aStopWatchTime

	self subclassResponsibility

! !

!StopWatchTime methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 10:15'!
percentOf: aStopWatchTime

	^self asTicks value*100/(aStopWatchTime asTicks value)
! !


!StopWatchTime methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:11'!
asMilliseconds
	self subclassResponsibility! !

!StopWatchTime methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:11'!
asSeconds
	self subclassResponsibility! !

!StopWatchTime methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:11'!
asTicks
	self subclassResponsibility! !


!StopWatchTime methodsFor: 'value' stamp: 'HAW 12/10/2000 10:24'!
value

	self subclassResponsibility.! !

!StopWatchTime methodsFor: 'value' stamp: 'HAW 12/10/2000 10:24'!
value: aValue

	self subclassResponsibility.
! !


!StopWatchTime methodsFor: 'printing' stamp: 'HAW 12/10/2000 10:44'!
printOn: aStream

	self subclassResponsibility! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StopWatchTime class
	instanceVariableNames: ''!

!StopWatchTime class methodsFor: 'ring entity' stamp: 'HAW 12/19/2000 09:08'!
cero

	Cero isNil ifTrue: [ self initializeCero. ].
	^Cero.

! !

!StopWatchTime class methodsFor: 'ring entity' stamp: 'HAW 12/19/2000 09:08'!
initializeCero

	Cero _ StopWatchTicks new: 0.

! !


!StopWatchTime class methodsFor: 'instance creation' stamp: 'HAW 12/10/2000 10:24'!
new: aValue

	^super new
		value: aValue;
		yourself.! !


StopWatchTime subclass: #Milliseconds
	instanceVariableNames: 'stopWatchTicks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Profiling support'!

!Milliseconds methodsFor: 'private' stamp: 'HAW 12/10/2000 10:34'!
stopWatchTicks

	stopWatchTicks isNil ifTrue: [ stopWatchTicks _ StopWatchTicks new: 0 ].
	^stopWatchTicks.! !


!Milliseconds methodsFor: 'value' stamp: 'HAW 12/10/2000 10:35'!
value
	^(self stopWatchTicks value)/(StopWatch ticksPerMillisecond)! !

!Milliseconds methodsFor: 'value' stamp: 'HAW 12/10/2000 10:35'!
value: aValue
	^self stopWatchTicks value: (aValue*StopWatch ticksPerMillisecond)! !


!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 12/10/2000 10:40'!
+ aStopWatchTime

	^(self stopWatchTicks + (aStopWatchTime asTicks)) asMilliseconds.! !

!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 5/29/2001 11:06'!
- aStopWatchTime

	^(self stopWatchTicks - (aStopWatchTime asTicks)) asMilliseconds.! !

!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:30'!
divideByANumber: aNumber

	^Milliseconds new: (self value / aNumber ).
! !

!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:55'!
divideStopWatchTime: aStopWatchTime

	^Milliseconds new: (aStopWatchTime asMilliseconds value / (self value)).
! !

!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:30'!
multiplyByANumber: aNumber

	^Milliseconds new: (self value * aNumber ).
! !

!Milliseconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:54'!
multiplyStopWatchTime: aStopWatchTime

	^Milliseconds new: (self value * (aStopWatchTime asMilliseconds value))! !


!Milliseconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:26'!
asMilliseconds

	^self! !

!Milliseconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:27'!
asSeconds

	^Seconds new: (self value/1000).! !

!Milliseconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:35'!
asTicks

	^self stopWatchTicks.! !


!Milliseconds methodsFor: 'printing' stamp: 'HAW 6/8/2001 10:17'!
printOn: aStream

	aStream
		nextPutAll: (self value roundTo: 0.01) printString;
		space;
		nextPutAll: 'Millis.'.! !

!Milliseconds methodsFor: 'printing' stamp: 'HAW 6/17/2001 23:48'!
valueAsString

	^(self value roundTo: 0.01) printString.
! !


StopWatchTime subclass: #Seconds
	instanceVariableNames: 'stopWatchTicks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Profiling support'!

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 5/29/2001 11:06'!
+ aStopWatchTime

	^(self stopWatchTicks + (aStopWatchTime asTicks)) asSeconds.! !

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 5/29/2001 11:06'!
- aStopWatchTime

	^(self stopWatchTicks - (aStopWatchTime asTicks)) asSeconds.! !

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:30'!
divideByANumber: aNumber

	^Seconds new: (self value / aNumber ).
! !

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:58'!
divideStopWatchTime: aStopWatchTime

	^Seconds new: (aStopWatchTime asSeconds value / (self value)).! !

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:30'!
multiplyByANumber: aNumber

	^Seconds new: (self value * aNumber ).
! !

!Seconds methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:56'!
multiplyStopWatchTime: aStopWatchTime

	^Seconds new: (self value * (aStopWatchTime asSeconds value)).! !


!Seconds methodsFor: 'private' stamp: 'HAW 12/10/2000 10:41'!
stopWatchTicks

	stopWatchTicks isNil ifTrue: [ stopWatchTicks _ StopWatchTicks new: 0 ].
	^stopWatchTicks.! !


!Seconds methodsFor: 'value' stamp: 'HAW 12/10/2000 10:41'!
value
	^(self stopWatchTicks value)/(StopWatch ticksPerSecond)! !

!Seconds methodsFor: 'value' stamp: 'HAW 12/10/2000 10:42'!
value: aValue
	^self stopWatchTicks value: (aValue*StopWatch ticksPerSecond)! !


!Seconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:43'!
asMilliseconds
	^Milliseconds new: (self value*1000).! !

!Seconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:42'!
asSeconds
	^self! !

!Seconds methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:43'!
asTicks
	^self stopWatchTicks.! !


!Seconds methodsFor: 'printing' stamp: 'HAW 6/6/2001 10:03'!
printOn: aStream

	aStream
		nextPutAll: (self value asFloat printString);
		space;
		nextPutAll: 'Seconds'.! !


StopWatchTime subclass: #StopWatchTicks
	instanceVariableNames: 'ticks '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thesis-Profiling support'!

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 12/10/2000 10:39'!
+ aStopWatchTime

	^StopWatchTicks new: (self value + aStopWatchTime asTicks value).
! !

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 5/29/2001 11:05'!
- aStopWatchTime

	^StopWatchTicks new: (self value - aStopWatchTime asTicks value).
! !

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:29'!
divideByANumber: aNumber

	^StopWatchTicks new: (self value / aNumber ).

! !

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:39'!
divideStopWatchTime: aStopWatchTime

	^StopWatchTicks new: ( aStopWatchTime asTicks value / self value).

! !

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:29'!
multiplyByANumber: aNumber

	^StopWatchTicks new: (self value * aNumber ).

! !

!StopWatchTicks methodsFor: 'aritmethics' stamp: 'HAW 12/25/2000 09:24'!
multiplyStopWatchTime: aStopWatchTime

	^StopWatchTicks new: (self value * aStopWatchTime asTicks value).

! !


!StopWatchTicks methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:28'!
asMilliseconds

	^Milliseconds new: (ticks/StopWatch ticksPerMillisecond)
! !

!StopWatchTicks methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:28'!
asSeconds

	^Seconds new: (self value/StopWatch ticksPerSecond)! !

!StopWatchTicks methodsFor: 'convertion' stamp: 'HAW 12/10/2000 10:13'!
asTicks

	^self.! !


!StopWatchTicks methodsFor: 'value' stamp: 'HAW 12/10/2000 10:25'!
value

	^ticks.! !

!StopWatchTicks methodsFor: 'value' stamp: 'HAW 12/10/2000 10:25'!
value: aValue

	ticks _ aValue.! !


!StopWatchTicks methodsFor: 'printing' stamp: 'HAW 12/10/2000 10:45'!
printOn: aStream

	aStream 
		nextPutAll: (self value printString);
		space;
		nextPutAll: 'Ticks'.! !
